
local LuckUseLayer = class("LuckUseLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function LuckUseLayer.create()
    local layer = LuckUseLayer.new()
    layer:createLayerMenu()
    return layer
end

function LuckUseLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.requestId = 0
	self.useTips = {
		[1] = "恭喜你，幸运值+1",
		[-1] = "很遗憾，幸运值-1",
		[0] = "幸运值不变"
	}
end


function LuckUseLayer:clear()
	self:removeFromParent()
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Use_Add_Luck")
end

function LuckUseLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/role/UseLuckLayer.csb"), "ccui.Widget")
	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget") 
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)
	
	local luckLabel = tolua.cast(mainPanel:getChildByName("Luck_Label"),"ccui.Text")
	luckLabel:setString(string.format("幸运值：%d",wd.GlobalData:getInstance():getRoleLuck()))
    local backBtn = ccui.Helper:seekWidgetByName(node,"Close_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
            end
        end
    )
	
	local enterBtn = ccui.Helper:seekWidgetByName(node,"Use_Button")
	enterBtn:setPressedActionEnabled(true)
    enterBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				if self.requestId ~= 0 then
					wd.TranscodingSend:useAddLuck(self.requestId)
				else
					wd.showRichTips(4,"请先选择一种祝福油")
				end
            end
        end
    )
	
	local luckItem = wd.GlobalData:getInstance():getToolsItemInXml(1026)
	local superLuckItem = wd.GlobalData:getInstance():getToolsItemInXml(1027)
	
	local luckBtn = ccui.Helper:seekWidgetByName(node,"Luck_Button")
	local luckColorSprite = tolua.cast(luckBtn:getChildByName("Color_Sprite"), "cc.Sprite")
	local luckItemSprite = tolua.cast(luckBtn:getChildByName("Item_Sprite"), "cc.Sprite")
	local luckSelectSprite = tolua.cast(luckBtn:getChildByName("Select_Sprite"), "cc.Sprite")
	local luckNumberLabel = tolua.cast(luckBtn:getChildByName("Number_Label"), "ccui.Text")
	local luckNameLabel = tolua.cast(luckBtn:getChildByName("Name_Label"), "ccui.Text")
	luckColorSprite:setSpriteFrame(string.format("%02d.png",luckItem:getQuality()))
	luckItemSprite:setSpriteFrame(string.format("%d.png",luckItem:getToolsId()))
	luckNumberLabel:setString(wd.GlobalData:getInstance():getToolsItemCountForId(1026))
	luckNameLabel:setString(luckItem:getName())
	luckNameLabel:setColor(wd.colorTable[luckItem:getQuality()])
	
	local superLuckBtn = ccui.Helper:seekWidgetByName(node,"SuperLuck_Button")
	local superLuckColorSprite = tolua.cast(superLuckBtn:getChildByName("Color_Sprite"), "cc.Sprite")
	local superLuckItemSprite = tolua.cast(superLuckBtn:getChildByName("Item_Sprite"), "cc.Sprite")
	local superLuckSelectSprite = tolua.cast(superLuckBtn:getChildByName("Select_Sprite"), "cc.Sprite")
	local superLuckNumberLabel = tolua.cast(superLuckBtn:getChildByName("Number_Label"), "ccui.Text")
	local superLuckNameLabel = tolua.cast(superLuckBtn:getChildByName("Name_Label"), "ccui.Text")
	superLuckColorSprite:setSpriteFrame(string.format("%02d.png",superLuckItem:getQuality()))
	superLuckItemSprite:setSpriteFrame(string.format("%d.png",superLuckItem:getToolsId()))
	superLuckNumberLabel:setString(wd.GlobalData:getInstance():getToolsItemCountForId(1027))
	superLuckNameLabel:setString(superLuckItem:getName())
	superLuckNameLabel:setColor(wd.colorTable[superLuckItem:getQuality()])
	
    luckBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				luckSelectSprite:setVisible(true)
				superLuckSelectSprite:setVisible(false)
				self.requestId = 1026
            end
        end
    )
	
	
    superLuckBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				luckSelectSprite:setVisible(false)
				superLuckSelectSprite:setVisible(true)
				self.requestId = 1027
            end
        end
    )
	
	
	
	local function onUseAddLuck()
		local useState = wd.GlobalData:getInstance():getUseLuckState()
		wd.showRichTips(4,self.useTips[useState])
		luckLabel:setString(string.format("幸运值：%d",wd.GlobalData:getInstance():getRoleLuck()))
		luckNumberLabel:setString(wd.GlobalData:getInstance():getToolsItemCountForId(1026))
		superLuckNumberLabel:setString(wd.GlobalData:getInstance():getToolsItemCountForId(1027))
	end
	local listener = cc.EventListenerCustom:create("Use_Add_Luck", onUseAddLuck)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end

return LuckUseLayer

