
local NewGuideLayer = class("NewGuideLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function NewGuideLayer.create()
    local layer = NewGuideLayer.new()
    layer:createLayerMenu()
    return layer
end

function NewGuideLayer:ctor()
	--cc.SpriteFrameCache:getInstance():addSpriteFrames("ui/newguide/newguide.plist", "ui/newguide/newguide.png")
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.step = 1
	self.fontSize = 20
	self.dirction ={
		["left"] = 90,
		["right"] = -90,
		["top"] = -180,
		["bottom"] = 0,
	}
	self.talkBoxLayout = {
		[1] = {x = -350, y = 250 },
		[2] = {x = 110, y = 230 },
		[3] = {x = 0, y = 0 },
		[4] = {x = 0, y = 0 },
		[5] = {x = -200, y = 400 },
		[6] = {x = -450, y = 50 },
		[7] = {x = -50, y = -160 },
		[8] = {x = 0, y = 0 },
		[9] = {x = 0, y = 350 },
		[10] = {x = 0, y = -170 },
		[11] = {x = -100, y = 350 },
		[12] = {x = -150, y = 280 },
	}
	
	self.talkContent = {
		[1] = "点击{r=[挂机战斗]}按钮进入战斗界面",
		[2] = "咱们来场{r=[快速战斗]},升级萌萌哒",
		[3] = "",
		[4] = "",
		[5] = "点击{r=[主城按钮]}回到主界面",
		[6] = "点击{r=[角色]}进入人物属性界面",
		[7] = "点击{r=[装备框]}",
		[8] = "",
		[9] = "点击{r=[装备按钮]}进行装备佩戴",
		[10] = "咱们来{r=[强化]}吧",
		[11] = "点击{r=[强化按钮]}，可对装备进行强化",
		[12] = "装备强化，就是那么牛",
	}
end

function NewGuideLayer:clear()
	self:removeFromParent()
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Handle_NewGuile")
end

function NewGuideLayer:createLayerMenu()
    local node = ccui.Widget:create()
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
	
	--gray
	local clipper = cc.ClippingNode:create()
	self:addChild(clipper)
	local grayLayer = cc.LayerColor:create(cc.c4b(0,0,0,100))
	clipper:addChild(grayLayer)
	local stencil = cc.Sprite:create()
	stencil:setSpriteFrame("ranking_number_box.png")
	
	local effect = cc.Sprite:create()
	self:addChild(effect,2)
	local animation = cc.Animation:create()

    for i = 1, 7 do
        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("newGuide_%02d.png", i)))
    end

    animation:setDelayPerUnit(0.1)
    animation:setLoops(1)
    local action = cc.Animate:create(animation)
	local repeatAction = cc.RepeatForever:create(action)
	effect:runAction(repeatAction)
	
	clipper:setInverted(true) -- //设置底板可见，显示剩余部分  
	clipper:setAlphaThreshold(0)  --//设置绘制底板的Alpha值为0  

	
    ccui.Helper:doLayout(node)
	
	local arrow = cc.Sprite:create()
	arrow:setSpriteFrame("newguide_arrow.png")
	arrow:setAnchorPoint(cc.p(0.5,0))
	self:addChild(arrow)
	
	local talkBox = cc.Sprite:create()
	talkBox:setSpriteFrame("newguide_talkbox.png")
	self:addChild(talkBox)
	talkBox:setVisible(false)
	
	local function handleArrow()
		arrow:setVisible(true)
		arrow:setRotation(self.dirction[wd.newGuideDir[self.step]])
		local pos = {}
		local moveBy
		if wd.newGuideDir[self.step] == "left" then
			pos.x = wd.newGuidePos[self.step].pos.x + wd.newGuidePos[self.step].size.width/2
			pos.y = wd.newGuidePos[self.step].pos.y
			moveBy = cc.MoveBy:create(0.5,cc.p(5,0))
		elseif wd.newGuideDir[self.step] == "right" then
			pos.x = wd.newGuidePos[self.step].pos.x - wd.newGuidePos[self.step].size.width/2
			pos.y = wd.newGuidePos[self.step].pos.y
			moveBy = cc.MoveBy:create(0.5,cc.p(-5,0))
		elseif wd.newGuideDir[self.step] == "top" then
			pos.x = wd.newGuidePos[self.step].pos.x 
			pos.y = wd.newGuidePos[self.step].pos.y - wd.newGuidePos[self.step].size.height/2
			moveBy = cc.MoveBy:create(0.5,cc.p(0,-5))
		elseif wd.newGuideDir[self.step] == "bottom" then
			pos.x = wd.newGuidePos[self.step].pos.x 
			pos.y = wd.newGuidePos[self.step].pos.y + wd.newGuidePos[self.step].size.height/2
			moveBy = cc.MoveBy:create(0.5,cc.p(0,5))
		end
		if self.step == 6 then
			pos.x = pos.x + 150
		end
		arrow:setPosition(pos)
		local moveByReverse = moveBy:reverse()
		local sequence = cc.Sequence:create(moveBy,moveByReverse)
		local repeatAct = cc.RepeatForever:create(sequence)
		arrow:runAction(repeatAct)
	end
	
	handleArrow()

	local function handleGrayLayer()
		stencil:setPosition(wd.newGuidePos[self.step].pos)
		clipper:setStencil(stencil) --//设置裁剪模板  
		effect:setPosition(wd.newGuidePos[self.step].pos)
	end
	handleGrayLayer()
	
	local function handleTalkBox()
		talkBox:setVisible(wd.newGuideIsShowTalk[self.step])
		local x,y = arrow:getPosition()
		talkBox:setPosition(cc.p(x+self.talkBoxLayout[self.step].x,y+self.talkBoxLayout[self.step].y))
		talkBox:removeAllChildren()
		if self.talkContent[self.step] ~= "" then
			local richElementList = {}
			local startIndex,lastIndex,str,color,index,colorStr
			local parsedStr = self.talkContent[self.step]
			self.tag = 1
			if type(parsedStr) == "string" then	
				local circleTime = 0
				while (string.find(parsedStr,"{") ~= nil)	
				do
					if circleTime > 30 then
						break
					end
					
					index= string.find(parsedStr,"{")
					local strType = string.sub(parsedStr,index+1,index+1)
					if strType == "r" then
						startIndex,lastIndex,str = string.find(parsedStr,"{r=%[(.-)%]}")  
						color = cc.c3b(255,0,0)
					end
					if startIndex and lastIndex and str then
						richElementList = self:parseStrAndSetRichElement(richElementList,parsedStr,startIndex,lastIndex,str,color)
						parsedStr = string.sub(parsedStr,lastIndex+1,-1)
					end
					circleTime = circleTime + 1
				end
				parsedStr = string.sub(parsedStr,1,-1) 
				local richElement = ccui.RichElementText:create(self.tag,cc.c3b(255,255,255),255,parsedStr,"Helvetica",self.fontSize)
				self.tag = self.tag+1
				table.insert(richElementList,richElement)
			end
			
			local richTextLabel = ccui.RichText:create()
			if richElementList then
				for i,v in ipairs(richElementList) do
					richTextLabel:pushBackElement(v)
				end
			end
			richTextLabel:formatText()
			local labelSize = richTextLabel:getContentSize()
			richTextLabel:ignoreContentAdaptWithSize(false)
			richTextLabel:setContentSize(300,self.fontSize)
			talkBox:addChild(richTextLabel)
			richTextLabel:setPosition(cc.p(370,90))
		end
	end
	handleTalkBox()
	
	
	local listener = cc.EventListenerTouchOneByOne:create()
	listener:setSwallowTouches(true)
	listener:registerScriptHandler(
        function(sender,eventType)
			local pos = sender:getLocation()
			if wd.newGuidePos[self.step] then
				local targetPos = wd.newGuidePos[self.step].pos
				local targetSize = wd.newGuidePos[self.step].size
				if (targetPos.x-targetSize.width/2 <= pos.x and pos.x <= targetPos.x + targetSize.width/2) 
					and (targetPos.y-targetSize.height/2 <= pos.y and pos.y <= targetPos.y + targetSize.height/2) then
					arrow:stopAllActions()
					arrow:setVisible(false)
					self.step = self.step + 1
					if self.step > 12 then
						self:clear()
					end
					return false
				else
					return true
				end
			end
        end
        ,cc.Handler.EVENT_TOUCH_BEGAN)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, -1)
	
	
	local function onhandleNewGuile(EventCustom)
		handleArrow()
		handleGrayLayer()
		handleTalkBox()
	end
	
	local listener = cc.EventListenerCustom:create("Handle_NewGuile", onhandleNewGuile)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end

function NewGuideLayer:parseStrAndSetRichElement(richElementList,parsedStr,startIndex,lastIndex,str,color)
	if not color then
		color = cc.c3b(255,0,0)
	end
	parsedStr = string.sub(parsedStr,1,startIndex-1)
	local richElement = ccui.RichElementText:create(self.tag,cc.c3b(255,255,255),255,parsedStr,"Helvetica",self.fontSize)
	self.tag = self.tag+1
	table.insert(richElementList,richElement)
	richElement = ccui.RichElementText:create(self.tag,color,255,str,"Helvetica",self.fontSize)
	self.tag = self.tag+1
	table.insert(richElementList,richElement)
	return richElementList
end


return NewGuideLayer