
local LotteryLayer = class("LotteryLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function LotteryLayer.create()
    local layer = LotteryLayer.new()
    layer:createLayerMenu()
    return layer
end

function LotteryLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.relativePos = {	--119/2为按钮半径
	[1] = {angel = 0,arrowX= 0,arrowY = 119/2},
	[2] = {angel = 30,arrowX=119/2*math.sin(math.rad(30)) ,arrowY = 119/2*math.cos(math.rad(30))},
	[3] = {angel = 60,arrowX=119/2*math.sin(math.rad(60)) ,arrowY = 119/2*math.cos(math.rad(60))},
	[4] = {angel = 90,arrowX= 119/2,arrowY = 0},
	[5] = {angel = 120,arrowX= 119/2*math.cos(math.rad(30)),arrowY = -119/2*math.sin(math.rad(30))},
	[6] = {angel = 150,arrowX= 119/2*math.cos(math.rad(60)),arrowY = -119/2*math.sin(math.rad(60))},
	[7] = {angel = 180,arrowX= 0,arrowY = -119/2},
	[8] = {angel = 210,arrowX= -119/2*math.cos(math.rad(30)),arrowY = -119/2*math.cos(math.rad(30))},
	[9] = {angel = 240,arrowX= -119/2*math.sin(math.rad(60)),arrowY = -119/2*math.cos(math.rad(60))},
	[10] = {angel = 270,arrowX= -119/2,arrowY = 0},
	[11] = {angel = 300,arrowX= -119/2*math.cos(math.rad(30)),arrowY = 119/2*math.sin(math.rad(30))},
	[12] = {angel = 330,arrowX= -119/2*math.cos(math.rad(60)),arrowY = 119/2*math.sin(math.rad(60))},
	}
	self.endKey = 1
	self.itemNodeList = {}
	self.tickSchedule = nil
end

function LotteryLayer:clear()
	self.itemNodeList = {}
	if self.tickSchedule ~= nil then
		cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.tickSchedule)
		self.tickSchedule = nil
	end
	self:removeFromParent()
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Play_Lottery_Action")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_Free_Count")
end

function LotteryLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/lottery/LotteryScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    

	self.swallowLayer = ccui.Widget:create()
	self.swallowLayer:setContentSize(self.visibleSize)
    node:addChild(self.swallowLayer)
	local listener = cc.EventListenerTouchOneByOne:create()
    listener:setSwallowTouches(true)
    listener:registerScriptHandler(
        function()
			if self.swallowLayer:isVisible() then
				return true
			else
				return false
			end
        end
        ,cc.Handler.EVENT_TOUCH_BEGAN)

    self:getEventDispatcher():addEventListenerWithSceneGraphPriority(listener,self.swallowLayer)
	self.swallowLayer:setVisible(false)
	
	
	--gray
	self.clipper = cc.ClippingNode:create()
	self:addChild(self.clipper)
	local grayLayer = cc.LayerColor:create(cc.c4b(0,0,0,160))
	self.clipper:addChild(grayLayer)
	self.stencil = cc.Sprite:create()
	self.stencil:setSpriteFrame("lottery_itembox.png")
	self.clipper:setInverted(true) -- //设置底板可见，显示剩余部分  
	self.clipper:setAlphaThreshold(0)  --//设置绘制底板的Alpha值为0  
	self.clipper:setStencil(self.stencil) --//设置裁剪模板 
	self.clipper:setVisible(false)
	ccui.Helper:doLayout(node)
	
    local backBtn = ccui.Helper:seekWidgetByName(node,"Close_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
            end
        end
    )
	
	local drawBtn = ccui.Helper:seekWidgetByName(node,"Draw_Button")
	drawBtn:setPressedActionEnabled(true)
    drawBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self.callBackIndex = 1
				self.round = 1
				self.roundCount = 36
				self.endKey = 1
                if wd.activityHandler:getLotteryFreeCount() > 0 then
				    wd.activityHandler:requestLuckDraw(1)
                else
                    local layerClass = require("src.tips.TipsBoxLayer")
                    local msgTable = {}
                    local msg = {}
                    local num = wd.GlobalData:getInstance():getRoleData():getRoleExtendData("buy_fuben_num")
                    table.insert(msg,"抽奖次数已用完，是否花")
                    table.insert(msg,string.format("{y=[%d元宝]}",200))
                    table.insert(msg,"进行一次抽奖？")
                    table.insert(msgTable,msg)
                    local function buyNumber()
                        if wd.GlobalData:getInstance():getRoleGem() < 200 then
                            local layerClass = require("src.game.charge.ChargeTipsScene")
                            local layer = layerClass:create()
                            self:getParent():addChild(layer)
                        else
                            wd.activityHandler:requestLuckDraw(2)
                        end
                    end
                    local buyLayer = layerClass.create("ui/commonality/16.png", msgTable,buyNumber)
                    self:addChild(buyLayer) 
                end
            end
        end
    )
    
    
    
    local timeLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Time_Label"), "ccui.Text")
    
    local startTime =  wd.GlobalData:getInstance():getActivityStartTime(106)
	local endTime = wd.GlobalData:getInstance():getActivityEndTime(106)
	local year,month,day
	year = os.date("%Y",startTime)
	month = os.date("%m",startTime)
	day = os.date("%d",startTime)
	local startStr = string.format("%04d.%02d.%02d",year,month,day)
	year = os.date("%Y",endTime)
	month = os.date("%m",endTime)
	day = os.date("%d",endTime)
	local endStr = string.format("%04d.%02d.%02d",year,month,day)
	timeLabel:setString(string.format("%s - %s",startStr,endStr))
    
    

	self.drawBtnPosX,self.drawBtnPosY = drawBtn:getPosition()
	
	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
	self.arrow = tolua.cast(mainPanel:getChildByName("Arrow_Sprite"),"cc.Sprite")
	
	local countLabel = tolua.cast(mainPanel:getChildByName("Count_Label"),"ccui.Text")
	local rechargesLabel = tolua.cast(mainPanel:getChildByName("Recharges_Label"),"ccui.Text")
	
	self.lotteryList = wd.activityHandler:getLotteryList()
	for i,v in ipairs(self.lotteryList) do
		local itemBox = tolua.cast(mainPanel:getChildByName(string.format("Item_Box_%d",i)),"ccui.Button")
		self.relativePos[i].x,self.relativePos[i].y = itemBox:getPosition()
		itemBox:addTouchEventListener(
			function(sender,eventType)
				if eventType == ccui.TouchEventType.ended then
					if v.awardList[1].itemType == wd.ItemType.Tools then 
						local item = wd.GlobalData:getInstance():getToolsItemInXml(tonumber(v.awardList[1].itemId))
						local layerClass =  require("game.package.ToolsTipsLayer")
						local layer = layerClass.create()
						layer:createLayerMenu(v.awardList[1].itemId,true)
						self:addChild(layer)
					elseif v.awardList[1].itemType == wd.ItemType.Equip then 
						local equip = wd.GlobalData:getInstance():getEquipItemInXml(tonumber(v.awardList[1].itemId))
						local layerClass = require("src.game.shop.ArtifactTipsLayer")
						local layer = layerClass.create()
						layer:createLayerMenu(equip)
						self:addChild(layer)
					end
				end
			end
		)
		self.itemNodeList[i] = tolua.cast(cc.CSLoader:createNode("ui/lottery/LotteryItemNode.csb"), "ccui.Widget")
		local itemSprite = tolua.cast(self.itemNodeList[i]:getChildByName("Item_Sprite"),"cc.Sprite")
		local numberLabel = tolua.cast(self.itemNodeList[i]:getChildByName("Number_Label"),"ccui.Text")
		itemSprite:setSpriteFrame(string.format("%d.png",v.awardList[1].itemId))
		numberLabel:setString(v.awardList[1].itemCount)
		itemBox:addChild(self.itemNodeList[i])
		self.itemNodeList[i]:setPosition(5,5)
	end
	 
	local function onPlayLotteryAction(EventCustom)
		self.swallowLayer:setVisible(true)
		self:playArrowAction()
	end
	
	local listener = cc.EventListenerCustom:create("Play_Lottery_Action", onPlayLotteryAction)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	
	local function onUpdateFreeCount(EventCustom)
		countLabel:setString(string.format("%d次",wd.activityHandler:getLotteryFreeCount()))
		-- local desTime = wd.activityHandler:getRecharges()
		if self.tickSchedule ~= nil then
			cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.tickSchedule)
			self.tickSchedule = nil
		end
        
        rechargesLabel:setString( wd.activityHandler:getRecharges())
		-- if desTime ~= 0 then
		-- 	rechargesLabel:setColor(cc.c3b(255,255,255))
		-- 	local h,m,s
		-- 	local function setTime()
		-- 		if desTime ~= 0 then
		-- 			h = math.floor(desTime/3600)
		-- 			m = math.floor(math.abs(desTime-3600*h)/60)
		-- 			s = math.abs(desTime-h*3600-m*60)
		-- 			rechargesLabel:setString(string.format("%02d:%02d:%02d",h,m,s))
		-- 		else
		-- 			if self.tickSchedule ~= nil then
		-- 				cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.tickSchedule)
		-- 				self.tickSchedule = nil
		-- 			end
		-- 			rechargesLabel:setColor(cc.c3b(255,0,0))
		-- 			rechargesLabel:setString("未开启")
		-- 		end
		-- 	end
		-- 	setTime()
		-- 	local function timeTick()
		-- 		setTime()
		-- 		desTime = desTime - 1
		-- 		if desTime < 0  then
		-- 			desTime = 0
		-- 		end
		-- 	end
		-- 	self.tickSchedule = cc.Director:getInstance():getScheduler():scheduleScriptFunc(timeTick, 1, false)
		-- else
		-- 	rechargesLabel:setColor(cc.c3b(255,0,0))
		-- 	rechargesLabel:setString("未开启")
		-- end
	end
	
	local listener = cc.EventListenerCustom:create("Update_Free_Count", onUpdateFreeCount)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
end

function LotteryLayer:playArrowAction()
	local index = 1
	local actionArray = {}
	repeat
		index = index + 1
		if index > self.roundCount then
			index = 1
		end
		local delay = cc.DelayTime:create(0.08)
		local finishDelayFunc = function()
			self:finishDelayFunc()
		end
		local delayCallBack = cc.CallFunc:create(finishDelayFunc)
		table.insert(actionArray,delayCallBack)
		table.insert(actionArray,delay)
	until index == self.endKey 
	local function finishCircleFunc()
		if self.round ~= 0 then
			self.endKey = wd.activityHandler:getLotteryId()
			self.roundCount = 12
			self:playArrowAction()
		else
			self.itemNodeList[self.endKey]:setVisible(false)
			self:showReward()
		end
		self.round = self.round - 1
	end
	local circleCallBack = cc.CallFunc:create(finishCircleFunc)
	table.insert(actionArray,circleCallBack)
	self:runAction(cc.Sequence:create(actionArray))	
end

function LotteryLayer:finishDelayFunc()
	self.callBackIndex = self.callBackIndex + 1
	if self.callBackIndex > 12 then
			self.callBackIndex = 1
	end
	--[[local rotateTo = cc.RotateTo:create(0,self.relativePos[self.callBackIndex].angel)
	self.arrow:runAction(rotateTo)--]]
	self.arrow:setRotation(self.relativePos[self.callBackIndex].angel)
	self.arrow:setPosition(self.drawBtnPosX+self.relativePos[self.callBackIndex].arrowX,self.drawBtnPosY+self.relativePos[self.callBackIndex].arrowY)
end

function LotteryLayer:showReward()
	self.clipper:setVisible(true)
	self.stencil:setPosition(self.relativePos[self.endKey].x,self.relativePos[self.endKey].y)
	local itemNode = tolua.cast(cc.CSLoader:createNode("ui/lottery/LotteryItemNode.csb"), "ccui.Widget")
	local itemSprite = tolua.cast(itemNode:getChildByName("Item_Sprite"),"cc.Sprite")
	local numberLabel = tolua.cast(itemNode:getChildByName("Number_Label"),"ccui.Text")
	itemSprite:setSpriteFrame(string.format("%d.png",self.lotteryList[self.endKey].awardList[1].itemId))
	numberLabel:setString(self.lotteryList[self.endKey].awardList[1].itemCount)
	self:addChild(itemNode,1)
	itemNode:setPosition(self.relativePos[self.endKey].x-30,self.relativePos[self.endKey].y-30)
	local delay = cc.DelayTime:create(1)
	local scaleTo = cc.ScaleTo:create(1.5,0.4)
	local moveTo = cc.MoveTo:create(1.5,wd.packageBtnPos)
	local spawn = cc.Spawn:create(scaleTo,moveTo)
	local finishDelayFunc = function()
		local getData = wd.GlobalData:getInstance():getMessage("Get_Item_Msg")
		local itemInfo = wd.getItemInfo(getData)
		if itemInfo~= nil and itemInfo.name ~= nil and itemInfo.color ~= nil and itemInfo.count ~= nil then
			local msg = {}
			table.insert(msg,"获得")
			table.insert(msg,string.format("{t=[%s],c=[%d]}",itemInfo.name,itemInfo.color))
			table.insert(msg,string.format("*%d",itemInfo.count))
			wd.showRichTips(wd.tipsType.Get,msg)
		end
		self.itemNodeList[self.endKey]:setVisible(true)
		local rotateTo = cc.RotateTo:create(0,self.relativePos[1].angel)
		self.arrow:runAction(rotateTo)
		self.arrow:setPosition(self.drawBtnPosX+self.relativePos[1].arrowX,self.drawBtnPosY+self.relativePos[1].arrowY)
		itemNode:removeFromParent()
		self.clipper:setVisible(false)
		self.swallowLayer:setVisible(false)
		wd.activityHandler:requestOpenLottery()
	end
	local delayCallBack = cc.CallFunc:create(finishDelayFunc)
	itemNode:runAction(cc.Sequence:create(delay,spawn,delayCallBack))
end

return LotteryLayer
