
local SelectAwardLayer = class("SelectAwardLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function SelectAwardLayer.create()
    local layer = SelectAwardLayer.new()
    --layer:createLayerMenu()
    return layer
end

function SelectAwardLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.isSeven = true
end


function SelectAwardLayer:clear()
	self:removeFromParent()
end

function SelectAwardLayer:createLayerMenu(id,awardList)
    local node = tolua.cast(cc.CSLoader:createNode("ui/activity/SelectAwardLayer.csb"), "ccui.Widget")
	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget") 
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)
	
    local backBtn = ccui.Helper:seekWidgetByName(node,"Close_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
            end
        end
    )
	
	local enterBtn = ccui.Helper:seekWidgetByName(node,"Enter_Button")
	enterBtn:setPressedActionEnabled(true)
    enterBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				if self.requestId then
					if not self.isSeven then
						wd.activityHandler:requestOpenActAward(id,self.requestId)
					else
						wd.activityHandler:requestStartActivityAward(id,self.requestId)
					end
					self:clear()
				end
            end
        end
    )
	
	local cancelBtn = ccui.Helper:seekWidgetByName(node,"Cancel_Button")
	cancelBtn:setPressedActionEnabled(true)
    cancelBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
            end
        end
    )
	
	local function handleSelect()
		for i = 1,3 do
			local selectSprite = tolua.cast(self.awardBtnList[i]:getChildByName("Select_Sprite"), "cc.Sprite")
			if self.selectTag == i then
				selectSprite:setVisible(true)
			else
				selectSprite:setVisible(false)
			end
		end
	end
	self.awardBtnList = {}
	for i,v in ipairs(awardList) do
		self.awardBtnList[i] = tolua.cast(mainPanel:getChildByName(string.format("Award_%d",i)),"ccui.Button")
		local colorSprite = tolua.cast(self.awardBtnList[i]:getChildByName("Color_Sprite"), "cc.Sprite")
		colorSprite:setSpriteFrame(string.format("%02d.png",5))
		
		local image = tolua.cast(self.awardBtnList[i]:getChildByName("Item_Sprite"), "cc.Sprite")
		image:setSpriteFrame(string.format("%d.png",v.itemId))
		 
		local nameLabel = tolua.cast(self.awardBtnList[i]:getChildByName("Name_Label"), "ccui.Text")
		nameLabel:setString(wd.GlobalData:getInstance():getEquipItemInXml(v.itemId):getName())
		nameLabel:setColor(wd.colorTable[5])
		
		wd.equipEffect(wd.GlobalData:getInstance():getEquipItemInXml(v.itemId), image)
		
		self.awardBtnList[i]:addTouchEventListener(
			function(sender,eventType)
				if eventType == ccui.TouchEventType.ended then
					self.requestId = v.itemId
					self.selectTag = i
					handleSelect()
				end
			end
		)
	end
	
end

function SelectAwardLayer:setIsSevenBool(isSeven)
	self.isSeven = isSeven
end

return SelectAwardLayer

