
local ArenaShowLayer = class("ArenaShowLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function ArenaShowLayer.create()
    local layer = ArenaShowLayer.new()
    layer:createLayerMenu()
    return layer
end

function ArenaShowLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	
end

function ArenaShowLayer:remove()
    self:removeFromParent()
end



function ArenaShowLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/arena/ArenaAwardShowLayer.csb"), "ccui.Widget")
    self:addChild(node)

    self.mainNode = node

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Close_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:remove()
            end
        end
    )
end


return ArenaShowLayer