
local BattleSettingsLayer = class("BattleSettingsLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function BattleSettingsLayer.create()
    local layer = BattleSettingsLayer.new()
    layer:createLayerMenu()
    return layer
end

function BattleSettingsLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
end

function BattleSettingsLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/battle/BattleSettingsLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)


    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Back_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )

    local cancelBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Cancel_Button"), "ccui.Widget")
    cancelBtn:setPressedActionEnabled(true)
    cancelBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    local color1Check = tolua.cast(ccui.Helper:seekWidgetByName(node,"Wirte_Check"), "ccui.CheckBox")
    local color2Check = tolua.cast(ccui.Helper:seekWidgetByName(node,"Green_Check"), "ccui.CheckBox")
    local color3Check = tolua.cast(ccui.Helper:seekWidgetByName(node,"Blue_Check"), "ccui.CheckBox")
    local color4Check = tolua.cast(ccui.Helper:seekWidgetByName(node,"Purple_Check"), "ccui.CheckBox")
    
    if wd.GlobalData:getInstance():getColorSettings(1) > 0 then
        color1Check:setSelected(true)
    end
    if wd.GlobalData:getInstance():getColorSettings(2) > 0 then
        color2Check:setSelected(true)
    end
    if wd.GlobalData:getInstance():getColorSettings(3) > 0 then
        color3Check:setSelected(true)
    end
    if wd.GlobalData:getInstance():getColorSettings(4) > 0 then
        color4Check:setSelected(true)
    end
    
    local saveBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Save_Button"), "ccui.Widget")
    saveBtn:setPressedActionEnabled(true)
    saveBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local color1 = 0
                local color2 = 0
                local color3 = 0
                local color4 = 0

                if color1Check:isSelected() == true then
                    color1 = 1
                end
                if color2Check:isSelected() == true then
                    color2 = 1
                end
                if color3Check:isSelected() == true then
                    color3 = 1
                end
                if color4Check:isSelected() == true then
                    color4 = 1
                end
                
                wd.GlobalData:getInstance():setColorSettings(1, color1);
                wd.GlobalData:getInstance():setColorSettings(2, color2);
                wd.GlobalData:getInstance():setColorSettings(3, color3);
                wd.GlobalData:getInstance():setColorSettings(4, color4);
                
                wd.TranscodingSend:setBattleSettings(color1, color2, color3, color4)
                self:removeFromParent()
            end
        end
    )


end


return BattleSettingsLayer