
local QuickBattleLayer = class("QuickBattleLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function QuickBattleLayer.create()
    local layer = QuickBattleLayer.new()
    return layer
end

function QuickBattleLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
end

function QuickBattleLayer:createLayerMenu(map_type, map_id)
    local node = tolua.cast(cc.CSLoader:createNode("ui/battle/QuickBattleLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)
    
    
    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Back_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )

    local role = wd.GlobalData:getInstance():getRoleData()
    local buyQuickNum = tonumber(role:getRoleExtendData("buyQuickNum")) + 1
    local gemLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Gem_Text"), "ccui.Text")
    gemLabel:setString(string.format("%d元宝",20*buyQuickNum))

    local vipLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Vip_Text"), "ccui.Text")
    vipLabel:setString(string.format("Vip%d",role:getVip()))
    
    local countLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Count_Text"), "ccui.Text")
    countLabel:setString(string.format("%d次",role:getQuickBattleBuy()))


    local enterBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Enter_Button"), "ccui.Widget")
	local x,y = enterBtn:getPosition()
	wd.newGuidePos[wd.newGuideStep.QuickEnter] = {}
	wd.newGuidePos[wd.newGuideStep.QuickEnter].pos = self:convertToWorldSpace(cc.p(x,y))
	wd.newGuidePos[wd.newGuideStep.QuickEnter].size = enterBtn:getContentSize()
    ------------------------------新手引导----------------------------
    local clippingLayer = require("src.game.guidance.GuidanceLayer"):create()
    if clippingLayer then
        clippingLayer:setGuidance(enterBtn,30,10,115,115)
        local msgTable = {}
        local msg = {}
        table.insert(msg,"轻轻点下确定就可以")
        table.insert(msg,"{r=[完成快速]}")
        table.insert(msg,"了哟！")
        table.insert(msgTable,msg)
        clippingLayer:setMsg(msgTable)
        self:addChild(clippingLayer)
    end
    ------------------------------------------------------------------
    enterBtn:setPressedActionEnabled(true)
    enterBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if wd.GlobalData:getInstance():getRoleGem() >= 20*buyQuickNum then
                    wd.TranscodingSend:setQuickBattle(map_type, map_id)
                else
                    local layerClass = require("src.game.charge.ChargeTipsScene")
                    local layer = layerClass:create()
                    self:getParent():addChild(layer)
                end
                if clippingLayer then
                    clippingLayer:removeFromParent()
                    clippingLayer = nil
                    local event = cc.EventCustom:new("guidance_offlineOpen")
                    cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
                end
                self:removeFromParent()
            end
        end
    )
    
    local cancelBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Cancel_Button"), "ccui.Widget")
    cancelBtn:setPressedActionEnabled(true)
    cancelBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    
    
end


return QuickBattleLayer