local BossChallengeTips = class("BossChallengeTips",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function BossChallengeTips.create()
    local layer = BossChallengeTips.new()
    return layer
end

function BossChallengeTips:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.dataHandler = wd.bossHandler
end

function BossChallengeTips:createLayerMenu(tag,itemList)
    local node = tolua.cast(cc.CSLoader:createNode("ui/boss/BossChallengeTipsLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
	
    local backBtn = tolua.cast(mainPanel:getChildByName("Close_Button"), "ccui.Button")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
	
	
	local challengeBtn = tolua.cast(mainPanel:getChildByName("Chanllenge_Button"), "ccui.Button")
    challengeBtn:setPressedActionEnabled(true)
    challengeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				-- 挑战
				self.dataHandler:setFightBossId(tag)
				local event = cc.EventCustom:new("Fight_Boss")
				cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
				--self:removeFromParent()
            end
        end
    )
	
	local itemListView = tolua.cast(mainPanel:getChildByName("ItemListView"), "ccui.ListView")
    for i,v in ipairs(itemList) do
		local btn = ccui.Button:create("item_button.png", "item_button.png", "", ccui.TextureResType.plistType)
		btn:setAnchorPoint(cc.p(0,0))
		local itemNode = tolua.cast(cc.CSLoader:createNode("ui/boss/ChallengeItemNode.csb"),"ccui.Widget")
		btn:addChild(itemNode)
		local color = tolua.cast(itemNode:getChildByName("Color_Sprite"), "cc.Sprite")
		
		local item = wd.GlobalData:getInstance():getToolsItemInXml(v.id)
			
		local colorStr = string.format("%02d.png",item:getQuality())
		btn:addTouchEventListener(
			function(sender,eventType)
				if eventType == ccui.TouchEventType.ended then
					local layerClass =  require("src.game.package.ToolsTipsLayer")
					local layer = layerClass.create()
					layer:createLayerMenu(v.id, true)
					self:addChild(layer)
				end
			end
		)
		local nameLabel = tolua.cast(itemNode:getChildByName("Name_Label"), "ccui.Text")
		nameLabel:setString(item:getName())
		local image = tolua.cast(itemNode:getChildByName("Item_Sprite"), "cc.Sprite")
		image:setSpriteFrame(string.format("%d.png",v.id))
		if item:getQuality() == 5 then
			wd.itemEffect(image)
		end
		local quantityLabel = tolua.cast(itemNode:getChildByName("Number_Label"), "ccui.Text")
		quantityLabel:setString(string.format("%d", v.itemCount))
		
		--[[if v.itemType == wd.rewardItemType.MAIL_GEM then
			colorStr = string.format("%02d.png",5)
		end--]]
		color:setSpriteFrame(colorStr)
		--itemNode:setPosition(0,0)
		itemListView:pushBackCustomItem(btn)
	end
end


return BossChallengeTips