local ChargeTipsScene = class("ChargeTipsScene",function()
    return cc.Layer:create()
end)

function ChargeTipsScene:create()
    local layer = ChargeTipsScene:new()
    layer:createLayerMenu()
    return layer
end

function ChargeTipsScene:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
end

function ChargeTipsScene:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/charge/ChargeTipsScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)
    
    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Back_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    local closeBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Close_Button"), "ccui.Widget")
    closeBtn:setPressedActionEnabled(true)
    closeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    local sureBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Sure_Button"), "ccui.Widget")
    sureBtn:setPressedActionEnabled(true)
    sureBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.charge.ChargeLayer")
                local layer = layerClass.create()
                self:getParent():addChild(layer)
                self:removeFromParent()
            end
        end
    )
    
end

return ChargeTipsScene