
local CheckInLayer = class("CheckInLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function CheckInLayer.create()
    local layer = CheckInLayer.new()
    layer:createLayerMenu()
    return layer
end

function CheckInLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
end

function CheckInLayer:clear()
	self:removeFromParent()
    cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("check_In")
end

function CheckInLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/checkIn/CheckInScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)
	
    local backBtn = ccui.Helper:seekWidgetByName(node,"Close_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if self.clippingLayer then
                    self.clippingLayer:removeFromParent()
                    self.clippingLayer = nil
                    local event = cc.EventCustom:new("guidance_tripodOpen")
                    cc.Director:getInstance():getEventDispatcher():dispatchEvent(event) 
                end
				self:clear()
            end
        end
    )
    
    local checkFunc = require("src.game.checkIn.CheckInTime")
	local role = wd.GlobalData:getInstance():getRoleData()
	local checkIn = tolua.cast(ccui.Helper:seekWidgetByName(node,"check_in"), "ccui.Button")
    ------------------------------新手引导----------------------------
    local clippingLayer = require("src.game.guidance.GuidanceLayer"):create()
    if clippingLayer then
        clippingLayer:setGuidance(checkIn,5,5,115,115)
        local msgTable = {}
        local msg = {}
        table.insert(msg,"咦，还能")
        table.insert(msg,"{r=[每日签到3次]}")
        table.insert(msg,"呢！")
        table.insert(msgTable,msg)
        clippingLayer:setMsg(msgTable)
        self:addChild(clippingLayer)
    end
    ------------------------------------------------------------------
    
    checkIn:setPressedActionEnabled(true)
    checkIn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if clippingLayer then
                    clippingLayer:removeFromParent()
                    clippingLayer = nil
                    ------------------------------新手引导----------------------------
                    local clippingLayer = require("src.game.guidance.GuidanceLayer"):create()
                    if clippingLayer then
                        clippingLayer:setGuidance(backBtn,30,50,115,115,nil,true)
                        local msgTable = {}
                        local msg = {}
                        table.insert(msg,"第一次")
                        table.insert(msg,"{r=[签到完毕]}")
                        table.insert(msg,"，瞬间萌萌哒！")
                        table.insert(msgTable,msg)
                        clippingLayer:setMsg(msgTable)
                        self:addChild(clippingLayer)
                        self.clippingLayer = clippingLayer
                    end
                    ------------------------------------------------------------------
                end
                if checkFunc:check() then
                    local num = tonumber(role:getRoleExtendData("signed_num"))
                    local packge = NetPackage:create()
                    packge:add("role_id",role:getRoleId())
                    packge:add("cishu",num + 1)
                    packge = packge:encode()
                    wd.TranscodingSend:luaSend(packge,ePCSignedReward)   
                    
                else
                    local hour = os.date("*t").hour
                    local str
                    local show_hour
                    if hour < 12 then
                        show_hour = 12
                        str  = "0~12"
                    elseif hour < 18 then 
                        show_hour = 18
                        str  = "12~18"
                    else
                        show_hour = 24
                        str  = "18~24"
                    end    
                    wd.showRichTips(4,str.."时段已经签到,请"..show_hour.."点后再来")
                end
            end
        end
    )

    local function updateUi()
        local num = tonumber(role:getRoleExtendData("signed_num"))    
        if num < 1 then
            return
        end     
        for n = 1,num do 
            local over = node:getChildByName("Panel_Main"):getChildByName("checkIn_over_"..n)
            over:setVisible(true)
        end
    end
    updateUi()
    
    local function checkTime()
        checkFunc:reset(function()
            for n = 1,3 do 
                local over = node:getChildByName("Panel_Main"):getChildByName("checkIn_over_"..n)
                over:setVisible(false)
            end
            updateUi()
            wd.showRichTips(4,"签到已经重置")
        end)
    end
    local delay = cc.DelayTime:create(1.0)
    local sequence = cc.Sequence:create(cc.CallFunc:create(checkTime),delay)
    self:runAction(cc.RepeatForever:create(sequence))
    
	local function updateCallBack(EventCustom)
		updateUi()
        local num = tonumber(role:getRoleExtendData("signed_num"))
        local gold = role:getLevel() * 1000 * num
        local msg = {}
        table.insert(msg,"获得")
        table.insert(msg,string.format("{t=[%s],c=[%d]}","金币",5))
        table.insert(msg,"*"..gold)
        wd.showRichTips(wd.tipsType.Get,msg)
        msg = {}
        if num == 3 then
            local gem = 100
            table.insert(msg,"获得")
            table.insert(msg,string.format("{t=[%s],c=[%d]}","元宝",5))
            table.insert(msg,"*"..gem)
            wd.showRichTips(wd.tipsType.Get,msg)
        end
	end
	
	local listener = cc.EventListenerCustom:create("check_In", updateCallBack)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);

end

return CheckInLayer
