
local EctypeInfoScene = class("EctypeInfoScene",function()
    return cc.Layer:create()
end)

function EctypeInfoScene:create(index)
    local layer = EctypeInfoScene.new()
    layer:createLayerMenu(index)
    return layer
end

function EctypeInfoScene:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
end

function EctypeInfoScene:createLayerMenu(index)
    local role = wd.GlobalData:getInstance():getRoleData()
    local node = tolua.cast(cc.CSLoader:createNode("ui/ectype/EctypeInfoScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

    local closeBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Close_Button"), "ccui.Button")
    closeBtn:setPressedActionEnabled(true)
    closeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    local listView = tolua.cast(ccui.Helper:seekWidgetByName(node,"list_view"), "ccui.ListView")
    
    
    local layoutWidth = 700
    local layoutHeight = 50
    
    local data = require("res.config.dict_fuben_gift")
    
    for i=1, #data do
        if data[i].index == index then
            local layout = ccui.Layout:create()
            layout:setContentSize(layoutWidth,layoutHeight)
            
            local label = ccui.Text:create()
            label:setAnchorPoint(cc.p(0.5,0.5))
            label:setString(data[i].hp_min.."~"..data[i].hp_max)
            label:setFontSize(24)
            label:setPosition(150,layoutHeight/2)
            layout:addChild(label)
            
            local labelTable = {}
            local gift = data[i].gift
            while(string.len(gift)>=5) do
                local startIndex,lastIndex,type,id,count  = string.find(gift,"(%d+)#(%d+)|(%d+)")
                local item = wd.GlobalData:getInstance():getToolsItemInXml(id)
                label = ccui.Text:create()
                label:setAnchorPoint(cc.p(0,0.5))
                label:setString(item:getName().." X "..count)
                label:setFontSize(24)
                layout:addChild(label)
                table.insert(labelTable,label)
                gift = string.sub(gift,lastIndex+1,-1)
            end
            local startPosition = layoutWidth/3*2 - (#labelTable - 1)*75
            for n = 1,#labelTable do
                labelTable[n]:setPosition(startPosition + (n - 1)*150,layoutHeight/2)
            end
                        
            listView:pushBackCustomItem(layout)
        end
    end
    
    
    
end

return EctypeInfoScene