local FamilyList = {}

function FamilyList:createList(size,data,listType)
    local item = cc.TableView:create(size)
    -- item:setViewSize(size)
    -- local function tableCellTouched(view, cell)
    --         local layerClass = require("src.game.soul.SoulTipsLayer")
	-- 		local layer = layerClass.create()
	-- 		layer:createLayerMenu(wd.soulHandler:setSoulItem(wd.GlobalData:getInstance():getSoulItem(cell:getTag())),2,self.wearRegion)
	-- 		self:addChild(layer)
    -- end
    
    local function numberOfCells(tableview)
        return #data
    end
    
    local function cellSizeForTable(table,idx)
        return 101
    end
    local function tableCellAtIndexForce(table,idx)
        local cell = table:dequeueCell()
        if not cell then
            cell = cc.TableViewCell:create()
			local familyNode =  tolua.cast(cc.CSLoader:createNode("ui/family/Family_List_Node.csb"),"ccui.Widget")
			local mainPanel = tolua.cast(familyNode:getChildByName("Main_Panel"), "ccui.Widget")
			ccui.Helper:doLayout(mainPanel)
            familyNode:setName("node")
            cell:addChild(familyNode)
        end  
        local familyNode = cell:getChildByName("node")
        local v = data[idx + 1]
        
        local mainPanel = tolua.cast(familyNode:getChildByName("Main_Panel"), "ccui.Widget")
        mainPanel:setContentSize(size.width,mainPanel:getContentSize().height)
        mainPanel:setSwallowTouches(false)
        ccui.Helper:doLayout(mainPanel)
        local rankingSprite = tolua.cast(mainPanel:getChildByName("Ranking_Sprite"), "cc.Sprite")
        if v.rank > 3 then
            local numberLabel = tolua.cast(mainPanel:getChildByName("Number_Label"), "ccui.TextAtlas")
            numberLabel:setString(string.format("%d",v.rank))
            rankingSprite:setVisible(false)
        else
            rankingSprite:setVisible(true)
            rankingSprite:setSpriteFrame(string.format("main_ranking_No%d.png",v.rank))
        end
        local nameLabel = tolua.cast(mainPanel:getChildByName("FamilyName_Label"), "ccui.Text")
        nameLabel:setString(v.name)
        local chairmanLabel = tolua.cast(mainPanel:getChildByName("ChairmanName_Label"), "ccui.Text")
        chairmanLabel:setString(v.chairmanName) 
        local levelLabel = tolua.cast(mainPanel:getChildByName("Level_Label"), "ccui.Text")
        levelLabel:setString(string.format("Lv:%d",v.level))
        local countLabel = tolua.cast(mainPanel:getChildByName("Count_Label"), "ccui.Text")
        countLabel:setString(string.format("%d/%d",v.curMemberCount,v.fullMemberCount))
        local declarationBox = tolua.cast(mainPanel:getChildByName("Declaration_Box"), "ccui.Widget")
        declarationBox:setSwallowTouches(false)
        local declarationLabel = tolua.cast(declarationBox:getChildByName("Declaration_Text"), "ccui.Text")
        declarationLabel:setString(string.format("宣言:%s",v.declaration))
        local requestButton = tolua.cast(mainPanel:getChildByName("Request_Button"),"ccui.Button")
        local unoperateTitle = tolua.cast(mainPanel:getChildByName("Unoperate_Title"), "cc.Sprite")
        if listType == wd.familyListType.Unjoined then
            unoperateTitle:setVisible(false)
            requestButton:setVisible(true)
            local titleSprite,btnSprite
            if v.curMemberCount < v.fullMemberCount then
                if v.job == wd.familyJobType.Family_Proposer then
                    titleSprite = "family_btntitle_cancel.png"
                    btnSprite = "package_red_normal.png"
                else
                    titleSprite = "family_btntitle_request.png"
                    btnSprite = "package_bule_normal.png"
                    requestButton:setPressedActionEnabled(true)
                    requestButton:addTouchEventListener(
                        function(sender,eventType)
                            if eventType == ccui.TouchEventType.ended then
                                wd.familyHandler:requestJoinFamily(v.id,idx)
                            end
                        end
                    )
                end
            else
                titleSprite = "family_btntitle_full.png"
                btnSprite = "family_red_btn.png"
            end
            requestButton:loadTextures(btnSprite,btnSprite,btnSprite,1)
            local btnTitle = tolua.cast(requestButton:getChildByName("Request_Btn_Title"), "cc.Sprite")
            btnTitle:setSpriteFrame(titleSprite)
        else
            unoperateTitle:setVisible(true)
            requestButton:setVisible(false)
        end
        
        return cell
    end
    

    item:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
    item:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN)
    item:setDelegate()
    item:registerScriptHandler(numberOfCells,cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
    item:registerScriptHandler(cellSizeForTable,cc.TABLECELL_SIZE_FOR_INDEX)
    item:registerScriptHandler(tableCellAtIndexForce,cc.TABLECELL_SIZE_AT_INDEX)
    -- item:registerScriptHandler(tableCellTouched, cc.TABLECELL_TOUCHED)
    item:reloadData()
    
    return item
end

return FamilyList