
local Family_AnnounceLayer = class("Family_AnnounceLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function Family_AnnounceLayer.create()
    local layer = Family_AnnounceLayer.new()
    layer:createLayerMenu()
    return layer
end

function Family_AnnounceLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.dataHandler = wd.familyHandler 
end

function Family_AnnounceLayer:clear()
	self:removeFromParent()
	--cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_AchieveList")
	
end

function Family_AnnounceLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/family/Family_AnnounceLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)
	
    local backBtn = ccui.Helper:seekWidgetByName(node,"Close_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
            end
        end
    )
	
	local inputBox =  tolua.cast(ccui.Helper:seekWidgetByName(node,"TextField"), "ccui.TextField")
	inputBox:setString(self.dataHandler:getChangeNoticeMsgByType(wd.familyNoticeType.Announcement))
	local enterBtn = ccui.Helper:seekWidgetByName(node,"Enter_Button")
	enterBtn:setPressedActionEnabled(true)
    enterBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self.dataHandler:setNoticeChangeMsg(wd.familyNoticeType.Announcement,inputBox:getString())
				self.dataHandler:requestChangeNotice(wd.familyNoticeType.Announcement,inputBox:getString())
            end
        end
    )
	
	local cancelBtn = ccui.Helper:seekWidgetByName(node,"Cancel_Button")
	cancelBtn:setPressedActionEnabled(true)
    cancelBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
            end
        end
    )

	
end

return Family_AnnounceLayer
