
local Family_Create_Layer = class("Family_Create_Layer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function Family_Create_Layer.create()
    local layer = Family_Create_Layer.new()
    layer:createLayerMenu()
    return layer
end

function Family_Create_Layer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.dataHandler = wd.familyHandler 
end

function Family_Create_Layer:clear()
	self:removeFromParent()
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Create_Family")
	
end

function Family_Create_Layer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/family/Family_Create_Layer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)
	
    local backBtn = ccui.Helper:seekWidgetByName(node,"Close_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
            end
        end
    )
	
	local inputTextBox = tolua.cast(ccui.Helper:seekWidgetByName(node,"Input_TextBox"), "ccui.TextField")
		
	local enterBtn = ccui.Helper:seekWidgetByName(node,"Enter_Button")
	enterBtn:setPressedActionEnabled(true)
    enterBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local text = inputTextBox:getString()
				if text ~= "" then
					self.dataHandler:requestCreateFamily(text)
				end
            end
        end
    )
	
	local cancelBtn = ccui.Helper:seekWidgetByName(node,"Cancel_Button")
	cancelBtn:setPressedActionEnabled(true)
    cancelBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
            end
        end
    )
end

return Family_Create_Layer
