local Family_Guard_Box = class("Family_Guard_Box",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function Family_Guard_Box.create()
    local layer = Family_Guard_Box.new()
    return layer
end

function Family_Guard_Box:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.dataHandler = wd.familyHandler 
end

function Family_Guard_Box:createLayerMenu(tag,itemList,status)
    local node = tolua.cast(cc.CSLoader:createNode("ui/familyGuard/familyGuard_baoxiang.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

    local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
    
    local backBtn = tolua.cast(mainPanel:getChildByName("Close_Button"), "ccui.Button")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    local challengeBtn = tolua.cast(mainPanel:getChildByName("Chanllenge_Button"), "ccui.Button")--领取
    challengeBtn:setPressedActionEnabled(true)
    challengeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self.dataHandler:requestGetFamilyBossBox(tag)
                self:removeFromParent()
            end
        end
    )

    local okBtn = tolua.cast(mainPanel:getChildByName("Enter_Button"), "ccui.Button")--确定
    okBtn:setPressedActionEnabled(true)
    okBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )

    if status == 1 then

    else
        challengeBtn:setVisible(false)
        okBtn:setVisible(true)

    end
   
    
    local itemListView= tolua.cast(mainPanel:getChildByName("ItemListView"), "ccui.ListView")
    itemListView:setPosition(cc.p(itemListView:getPositionX()+10,itemListView:getPositionY()))
    for i,v in ipairs(itemList) do
        local btn = ccui.Button:create("item_button.png", "item_button.png", "", ccui.TextureResType.plistType)
        btn:setAnchorPoint(cc.p(0,0))
        local itemNode = tolua.cast(cc.CSLoader:createNode("ui/boss/ChallengeItemNode.csb"),"ccui.Widget")
        btn:addChild(itemNode)
        itemNode:getChildByName("boss_tips_probability_1"):setVisible(false)
        local color = tolua.cast(itemNode:getChildByName("Color_Sprite"), "cc.Sprite")
        if v.type == 1 then
            local item = wd.GlobalData:getInstance():getToolsItemInXml(v.id)
            local colorStr = string.format("%02d.png",item:getQuality())
            btn:addTouchEventListener(
                function(sender,eventType)
                    if eventType == ccui.TouchEventType.ended then
                        local layerClass =  require("src.game.package.ToolsTipsLayer")
                        local layer = layerClass.create()
                        layer:createLayerMenu(v.id, true)
                        self:addChild(layer)
                    end
                end
            )
            local nameLabel = tolua.cast(itemNode:getChildByName("Name_Label"), "ccui.Text")
            nameLabel:setString(item:getName())
            local image = tolua.cast(itemNode:getChildByName("Item_Sprite"), "cc.Sprite")
            image:setSpriteFrame(string.format("%d.png",v.id))
            if item:getQuality() == 5 then
               wd.itemEffect(image)
           end
            local quantityLabel = tolua.cast(itemNode:getChildByName("Number_Label"), "ccui.Text")
            quantityLabel:setString(string.format("%d", v.itemCount))
            color:setSpriteFrame(colorStr)
            itemListView:pushBackCustomItem(btn)
        elseif v.type == 4 and v.id == 11 then
            local colorStr = string.format("03.png")
            local nameLabel = tolua.cast(itemNode:getChildByName("Name_Label"), "ccui.Text")
            nameLabel:setString("贡献点")
            local image = tolua.cast(itemNode:getChildByName("Item_Sprite"), "cc.Sprite")
            image:setSpriteFrame("4.png")
            local quantityLabel = tolua.cast(itemNode:getChildByName("Number_Label"), "ccui.Text")
            quantityLabel:setString(string.format("%d", v.itemCount))
            color:setSpriteFrame(colorStr)
            itemListView:pushBackCustomItem(btn)
        end
    end
end


return Family_Guard_Box