local Family_Guard_Tip = class("Family_Guard_Tip",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function Family_Guard_Tip.create()
    local layer = Family_Guard_Tip.new()
    return layer
end

function Family_Guard_Tip:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.dataHandler = wd.familyHandler 
end

function Family_Guard_Tip:createLayerMenu(tag,itemList,name,level,hp)
    local node = tolua.cast(cc.CSLoader:createNode("ui/boss/BossChallengeTipsLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

    local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
    
    local backBtn = tolua.cast(mainPanel:getChildByName("Close_Button"), "ccui.Button")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    
    local challengeBtn = tolua.cast(mainPanel:getChildByName("Chanllenge_Button"), "ccui.Button")
    challengeBtn:setPressedActionEnabled(true)
    challengeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                --self.dataHandler:requestStartFamilyBoss(tag)
                self:getParent():getParent():setFamilyBossBattle(tag,name,level,hp)
                local event = cc.EventCustom:new("RemoveFamilyMineLayer")
                cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
                self:getParent():clear()
                
            end
        end
    )
    
    local itemListView = tolua.cast(mainPanel:getChildByName("ItemListView"), "ccui.ListView")
    
   --[[ for i,v in ipairs(itemList) do
        local btn = ccui.Button:create("item_button.png", "item_button.png", "", ccui.TextureResType.plistType)
        btn:setAnchorPoint(cc.p(0,0))
        local itemNode = tolua.cast(cc.CSLoader:createNode("ui/boss/ChallengeItemNode.csb"),"ccui.Widget")
        btn:addChild(itemNode)
        local color = tolua.cast(itemNode:getChildByName("Color_Sprite"), "cc.Sprite")
        if v.type == 1 then
            local item = wd.GlobalData:getInstance():getToolsItemInXml(v.id)
            local colorStr = string.format("%02d.png",item:getQuality())
            btn:addTouchEventListener(
                function(sender,eventType)
                    if eventType == ccui.TouchEventType.ended then
                        local layerClass =  require("src.game.package.ToolsTipsLayer")
                        local layer = layerClass.create()
                        layer:createLayerMenu(v.id, true)
                        self:addChild(layer)
                    end
                end
            )
            local nameLabel = tolua.cast(itemNode:getChildByName("Name_Label"), "ccui.Text")
            nameLabel:setString(item:getName())
            local image = tolua.cast(itemNode:getChildByName("Item_Sprite"), "cc.Sprite")
            image:setSpriteFrame(string.format("%d.png",v.id))
            if item:getQuality() == 5 then
               wd.itemEffect(image)
           end
            local quantityLabel = tolua.cast(itemNode:getChildByName("Number_Label"), "ccui.Text")
            quantityLabel:setString(string.format("%d", v.itemCount))
            color:setSpriteFrame(colorStr)
            itemListView:pushBackCustomItem(btn)
        end
    end--]]
    local label = ccui.Text:create()
    label:setString("挑战它每次可得" .. itemList .. "贡献值，击杀者可获得贡献值翻倍。")

    label:setPosition( mainPanel:getChildByName("tools_get_title_3"):getPositionX(), mainPanel:getChildByName("tools_get_title_3"):getPositionY()-100)
    label:setScale(1.5)
    mainPanel:addChild(label)
end


return Family_Guard_Tip