
local Family_List_AllLayer = class("Family_List_AllLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function Family_List_AllLayer.create()
    local layer = Family_List_AllLayer.new()
    --layer:createLayerMenu()
    return layer
end

function Family_List_AllLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.dataHandler = wd.familyHandler 
end

function Family_List_AllLayer:setFamilyListType(listType)
	self.listType = listType
end

function Family_List_AllLayer:clear()
	self:removeFromParent()
	local event = cc.EventCustom:new("RemoveFamilyListLayer")
	cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_FamilyList")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Create_Family")
end

function Family_List_AllLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/family/Family_List_AllScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)
	
    local backBtn = ccui.Helper:seekWidgetByName(node,"Back_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
				cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Join_Family")
            end
        end
    )
	
	local requestBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Request_Button"), "ccui.Button")
    requestBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local layerClass = require("src.game.family.Family_List_RequestLayer")
                local layer = layerClass.create()
				layer:setFamilyListType(self.listType)
				layer:createLayerMenu()
                self:getParent():addChild(layer)
				self:clear()
            end
        end
    )
	
	local createBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Create_Button"), "ccui.Button")
    createBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local layerClass = require("src.game.family.Family_Create_Layer")
                local layer = layerClass.create()
                self:addChild(layer)
            end
        end
    )
	

	local familyListView
    local familyView = tolua.cast(ccui.Helper:seekWidgetByName(node,"Family_View"), "ccui.ListView")
		
	local function onUpdateFamilyList(EventCustom)
		familyView:removeAllItems()
		local familyList = self.dataHandler:getFamilyList()
        
        familyListView = require("src.game.family.FamilyList"):createList(familyView:getContentSize(),familyList,self.listType)
        familyView:addChild(familyListView)
	end
	
	local function onJoinFamily()
		if self.dataHandler:getJoinTag() then
			wd.showRichTips(4,"申请成功")
			self.dataHandler:setHadJoinTag(self.dataHandler:getJoinTag())
			local widget = familyListView:cellAtIndex(self.dataHandler:getJoinTag())
			if widget then
				local node = widget:getChildByName("node")
				if node then
					local mainPanel = tolua.cast(node:getChildByName("Main_Panel"), "ccui.Widget")
					local requestButton = tolua.cast(mainPanel:getChildByName("Request_Button"),"ccui.Button")
					requestButton:loadTextures("package_red_normal.png","package_red_normal.png","package_red_normal.png",1)
					local btnTitle = tolua.cast(requestButton:getChildByName("Request_Btn_Title"), "cc.Sprite")
					btnTitle:setSpriteFrame("family_btntitle_cancel.png")
				end
			end
		end
	end
	
	local listener = cc.EventListenerCustom:create("Update_FamilyList", onUpdateFamilyList)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	local listener = cc.EventListenerCustom:create("Join_Family", onJoinFamily)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	local function onCreateFamily(EventCustom)
		wd.showRichTips(4,"创建成功")
		self.dataHandler:requestOpenFamily()
		self:clear()
		cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Join_Family")
	end
	
	local listener = cc.EventListenerCustom:create("Create_Family", onCreateFamily)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end

return Family_List_AllLayer
