
local Family_List_RequestLayer = class("Family_List_RequestLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function Family_List_RequestLayer.create()
    local layer = Family_List_RequestLayer.new()
    --layer:createLayerMenu()
    return layer
end

function Family_List_RequestLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.dataHandler = wd.familyHandler 
end

function Family_List_RequestLayer:setFamilyListType(listType)
	self.listType = listType
end

function Family_List_RequestLayer:clear()
	self:removeFromParent()
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Create_Family")
end

function Family_List_RequestLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/family/Family_List_RequestScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)
	
    local backBtn = ccui.Helper:seekWidgetByName(node,"Close_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
				cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Join_Family")
            end
        end
    )
	
	local allBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"All_Button"), "ccui.Button")
    allBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self.dataHandler:requestGetAllFamilyInfo()
				local layerClass = require("src.game.family.Family_List_AllLayer")
                local layer = layerClass.create()
				layer:setFamilyListType(self.listType)
				layer:createLayerMenu()
                self:getParent():addChild(layer)
				self:clear()
            end
        end
    )
	
	local createBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Create_Button"), "ccui.Button")
    createBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local layerClass = require("src.game.family.Family_Create_Layer")
                local layer = layerClass.create()
                self:addChild(layer)
            end
        end
    )
	
	-- local familyListView = tolua.cast(ccui.Helper:seekWidgetByName(node,"Family_ListView"), "ccui.ListView")
	-- local listViewWidth = familyListView:getContentSize().width
	
	-- familyListView:removeAllItems()
	-- local familyList = self.dataHandler:getCanJoinFamilyList()
	-- for i,v in ipairs(familyList) do
	-- 	local widget = ccui.Widget:create()
	-- 	local familyNode =  tolua.cast(cc.CSLoader:createNode("ui/family/Family_List_Node.csb"),"ccui.Widget")
	-- 	local mainPanel = tolua.cast(familyNode:getChildByName("Main_Panel"), "ccui.Widget")
	-- 	local size = mainPanel:getContentSize()
	-- 	size.width = listViewWidth
	-- 	mainPanel:setContentSize(size)
	-- 	mainPanel:setSwallowTouches(false)
	-- 	ccui.Helper:doLayout(mainPanel)
	-- 	widget:setContentSize(size)
	-- 	local rankingSprite = tolua.cast(mainPanel:getChildByName("Ranking_Sprite"), "cc.Sprite")
	-- 	if v.rank > 3 then
	-- 		local numberLabel = tolua.cast(mainPanel:getChildByName("Number_Label"), "ccui.TextAtlas")
	-- 		numberLabel:setString(string.format("%d",v.rank))
	-- 		rankingSprite:setVisible(false)
	-- 	else
	-- 		rankingSprite:setVisible(true)
	-- 		rankingSprite:setSpriteFrame(string.format("main_ranking_No%d.png",v.rank))
	-- 	end
	-- 	local nameLabel = tolua.cast(mainPanel:getChildByName("FamilyName_Label"), "ccui.Text")
	-- 	nameLabel:setString(v.name)
	-- 	local chairmanLabel = tolua.cast(mainPanel:getChildByName("ChairmanName_Label"), "ccui.Text")
	-- 	chairmanLabel:setString(v.chairmanName) 
	-- 	local levelLabel = tolua.cast(mainPanel:getChildByName("Level_Label"), "ccui.Text")
	-- 	levelLabel:setString(string.format("Lv:%d",v.level))
	-- 	local countLabel = tolua.cast(mainPanel:getChildByName("Count_Label"), "ccui.Text")
	-- 	countLabel:setString(string.format("%d/%d",v.curMemberCount,v.fullMemberCount))
	-- 	local declarationBox = tolua.cast(mainPanel:getChildByName("Declaration_Box"), "ccui.Widget")
	-- 	declarationBox:setSwallowTouches(false)
	-- 	local declarationLabel = tolua.cast(declarationBox:getChildByName("Declaration_Text"), "ccui.Text")
	-- 	declarationLabel:setString(string.format("宣言:%s",v.declaration))
	-- 	local requestButton = tolua.cast(mainPanel:getChildByName("Request_Button"),"ccui.Button")
	-- 	local unoperateTitle = tolua.cast(mainPanel:getChildByName("Unoperate_Title"), "cc.Sprite")
	-- 	if self.listType == wd.familyListType.Unjoined then
	-- 		unoperateTitle:setVisible(false)
	-- 		requestButton:setVisible(true)
	-- 		local titleSprite,btnSprite
	-- 		if v.curMemberCount < v.fullMemberCount then
	-- 			if v.job == wd.familyJobType.Family_Proposer or i == self.dataHandler:getHadJoinTag() then
	-- 				titleSprite = "family_btntitle_cancel.png"
	-- 				btnSprite = "package_red_normal.png"
	-- 			else
	-- 				titleSprite = "family_btntitle_request.png"
	-- 				btnSprite = "package_green_normal.png"
	-- 				requestButton:setPressedActionEnabled(true)
	-- 				requestButton:addTouchEventListener(
	-- 					function(sender,eventType)
	-- 						if eventType == ccui.TouchEventType.ended then
	-- 							self.dataHandler:requestJoinFamily(v.id,i)
	-- 						end
	-- 					end
	-- 				)
	-- 			end
	-- 		else
	-- 			titleSprite = "family_btntitle_full.png"
	-- 			btnSprite = "family_red_btn.png"
	-- 		end
	-- 		requestButton:loadTextures(btnSprite,btnSprite,btnSprite,1)
	-- 		local btnTitle = tolua.cast(requestButton:getChildByName("Request_Btn_Title"), "cc.Sprite")
	-- 		btnTitle:setSpriteFrame(titleSprite)
	-- 	else
	-- 		unoperateTitle:setVisible(true)
	-- 		requestButton:setVisible(false)
	-- 	end
	-- 	--btnTitle:setString(v.stateStr)
	-- 	widget:setAnchorPoint(cc.p(0,0))
	-- 	widget:setTag(i)
	-- 	widget:addChild(familyNode)
	-- 	familyNode:setPosition(cc.p(0,0))
	-- 	familyNode:setTag(i)
	-- 	familyListView:pushBackCustomItem(widget)
	-- end
    local familyListView
    local familyView = tolua.cast(ccui.Helper:seekWidgetByName(node,"Family_View"), "ccui.ListView")
    familyView:removeAllItems()
    local familyList = self.dataHandler:getFamilyList()
    
    familyListView = require("src.game.family.FamilyList"):createList(familyView:getContentSize(),familyList,self.listType)
    familyView:addChild(familyListView)
    
	local function onJoinFamily()
		if self.dataHandler:getJoinTag() then
			wd.showRichTips(4,"申请成功")
			self.dataHandler:setHadJoinTag(self.dataHandler:getJoinTag())
			local widget = familyListView:cellAtIndex(self.dataHandler:getJoinTag())
			if widget then
				local node = widget:getChildByName("node")
				if node then
					local mainPanel = tolua.cast(node:getChildByName("Main_Panel"), "ccui.Widget")
					local requestButton = tolua.cast(mainPanel:getChildByName("Request_Button"),"ccui.Button")
					requestButton:loadTextures("package_red_normal.png","package_red_normal.png","package_red_normal.png",1)
					local btnTitle = tolua.cast(requestButton:getChildByName("Request_Btn_Title"), "cc.Sprite")
					btnTitle:setSpriteFrame("family_btntitle_cancel.png")
				end
			end
		end
	end
	
	local listener = cc.EventListenerCustom:create("Join_Family", onJoinFamily)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	local function onCreateFamily(EventCustom)
		wd.showRichTips(4,"创建成功")
		self.dataHandler:requestOpenFamily()
		self:clear()
		cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Join_Family")
	end
	
	local listener = cc.EventListenerCustom:create("Create_Family", onCreateFamily)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end

return Family_List_RequestLayer

