
local Family_Member_ListLayer = class("Family_Member_ListLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function Family_Member_ListLayer.create()
    local layer = Family_Member_ListLayer.new()
    layer:createLayerMenu()
    return layer
end

function Family_Member_ListLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.dataHandler = wd.familyHandler 
end

function Family_Member_ListLayer:clear()
	self:removeFromParent()
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_MemberList")
end

function Family_Member_ListLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/family/Family_Mine_MemberScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)
	
    local backBtn = ccui.Helper:seekWidgetByName(node,"Close_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local event = cc.EventCustom:new("RemoveFamilyMineLayer")
				cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
				self:clear()
            end
        end
    )
	
	local infoBtn = ccui.Helper:seekWidgetByName(node,"Info_Button")
	infoBtn:setPressedActionEnabled(true)
    infoBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self.dataHandler:requestOpenFamily()
				cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Operate_Family")
				local layerClass = require("src.game.family.Family_Member_InfoLayer")
                self:getParent().familyMineLayer = layerClass.create()
                self:getParent():addChild(self:getParent().familyMineLayer)
				self:clear()
            end
        end
    )
	
	local templeBtn = ccui.Helper:seekWidgetByName(node,"Temple_Button")
	templeBtn:setPressedActionEnabled(true)
    templeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local layerClass = require("src.game.family.Family_Member_TempleLayer")
                self:getParent().familyMineLayer = layerClass.create()
                self:getParent():addChild(self:getParent().familyMineLayer)
				self:clear()
				--wd.showSystemTips("暂未开放")
            end
        end
    )
	

    local device = require("cocos.framework.device")
    if device.platform == "ios" and wd.GlobalData:getInstance():getSdk() == 8 then
    	templeBtn:setVisible(false)
		local Panel_Button = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Button"), "ccui.Widget")
		local templeTtile = tolua.cast(Panel_Button:getChildByName("family_request_disable_10"), "cc.Sprite")
		-- local templeTtile = ccui.Helper:seekWidgetByName(node,"family_request_disable_11")
		templeTtile:setVisible(false)
    end
	
	local memberListView = tolua.cast(ccui.Helper:seekWidgetByName(node,"Member_ListView"), "ccui.ListView")
	local listViewWidth = memberListView:getContentSize().width
	
	
	local hidePanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Hide_Panel"), "ccui.Widget")
	local function onUpdateMemberList()
		memberListView:removeAllItems()
		local memberList = self.dataHandler:getFamilyMemberList()
		local chairmanId = self.dataHandler:getChairmanId()
		local viceChairmanId = self.dataHandler:getViceChairmanId()
		local canOperate = false
		local canCommission = false
		if wd.GlobalData:getInstance():getRoleId() == chairmanId or wd.GlobalData:getInstance():getRoleId() == viceChairmanId then
			canOperate = true
			if wd.GlobalData:getInstance():getRoleId() == chairmanId then
				canCommission = true
			end
		end
		for index,member in ipairs(memberList) do
			local widget = ccui.Widget:create()
			local memberNode =  tolua.cast(cc.CSLoader:createNode("ui/family/Family_Member_Node.csb"),"ccui.Widget")
			local mainPanel = tolua.cast(memberNode:getChildByName("Main_Panel"), "ccui.Widget")
			
			local size = mainPanel:getContentSize()
			size.width = listViewWidth
			widget:setContentSize(size)
			mainPanel:setContentSize(size)
			mainPanel:setSwallowTouches(false)
			ccui.Helper:doLayout(mainPanel)
			
			local headButton = tolua.cast(mainPanel:getChildByName("Head_Button"),"ccui.Button")
			headButton:setEnabled(true)
			headButton:addTouchEventListener(
				function(sender,eventType)
					if eventType == ccui.TouchEventType.ended then
						if member.id ~= wd.GlobalData:getInstance():getRoleId() then
							local layerClass = require("src.game.arena.PlayerLayer")
							local layer = layerClass.create()
							layer:createLayerMenu(wd.PlayerType.ENEMY)
							self:addChild(layer)
							wd.TranscodingSend:getPlayerData(member.id)
						end
					end
				end
			)
			local headSprite =  tolua.cast(mainPanel:getChildByName("Head_Sprite"), "cc.Sprite")
			headSprite:setSpriteFrame(wd.getHeadImageName(member.occupation, member.sex))
			
			local job = tolua.cast(mainPanel:getChildByName("Job_Title"), "cc.Sprite")
			job:setSpriteFrame(wd.getEquipTitleName(member.occupation))
			
			local nameLabel = tolua.cast(mainPanel:getChildByName("Name_Label"), "ccui.Text")
			nameLabel:setString(member.name)
			local levelLabel = tolua.cast(mainPanel:getChildByName("Level_Label"), "ccui.Text")
			levelLabel:setString(string.format("Lv:%d",member.level))
			local vipLabel = tolua.cast(mainPanel:getChildByName("Vip_Label"), "ccui.Text")
			vipLabel:setString(string.format("Vip:%d",member.vipLevel))
			local fightPowerLabel = tolua.cast(mainPanel:getChildByName("FightPower_Label"), "ccui.Text")
			fightPowerLabel:setString(member.fightPower)
			local contributeLabel = tolua.cast(mainPanel:getChildByName("Contribute_Label"), "ccui.Text")
			contributeLabel:setString(member.contribute)
			local jobLabel = tolua.cast(mainPanel:getChildByName("Job_Label"), "ccui.Text")
			jobLabel:setString(member.jobStr)
			local onlineLabel = tolua.cast(mainPanel:getChildByName("Online_Label"), "ccui.Text")
			onlineLabel:setString(member.offlineTime)
			
			local btnPanel = tolua.cast(mainPanel:getChildByName("Redict_Btn_Panel"), "ccui.Widget")
			btnPanel:setSwallowTouches(false)
			
			local commissionBtn = tolua.cast(btnPanel:getChildByName("Commission_Button"),"ccui.Button")
			commissionBtn:setPressedActionEnabled(true)
			commissionBtn:addTouchEventListener(
				function(sender,eventType)
					if eventType == ccui.TouchEventType.ended then
						-- 任命
						if canCommission then
							hidePanel:setVisible(true)
							hidePanel:addTouchEventListener(
								function(sender,eventType)
									if eventType == ccui.TouchEventType.ended then
										self.operatorLayer:removeFromParent()
										self.operatorLayer = nil
										hidePanel:setVisible(false)
									end
								end
							)
							
							local layerClass = require("src.game.family.Family_Operate_Layer")
							local x,y = btnPanel:getPosition()
							local pos  = btnPanel:getParent():convertToWorldSpace(cc.p(x,y))
							self.operatorLayer = layerClass.create(pos,member.job,member.name,member.id)
							self:addChild(self.operatorLayer,99)
						else
							wd.showRichTips(4,"只有族长能执行任命操作")
						end
					end
				end
			)
			
			local kickoutBtn = tolua.cast(btnPanel:getChildByName("Kickout_Button"),"ccui.Button")
			kickoutBtn:setPressedActionEnabled(true)
			kickoutBtn:addTouchEventListener(
				function(sender,eventType)
					if eventType == ccui.TouchEventType.ended then
						-- 踢出
						local layerClass = require("src.game.family.Family_MessageBox_Layer")
						local msg = {}
						table.insert(msg,"是否将")
						table.insert(msg,string.format("{n=[%s]}",member.name))
						table.insert(msg,"踢出家族")
						local function kickout()
							self.dataHandler:requestKickout(member.id)
						end
						self.tipsLayer = layerClass.create("family_subtitle_kickout.png",msg,kickout)
						self:addChild(self.tipsLayer)
					end
				end
			)
			
			local unoperateTitle = tolua.cast(mainPanel:getChildByName("Unoperate_Title"), "cc.Sprite")
			local isVisible
			if canOperate and member.id ~= wd.GlobalData:getInstance():getRoleId()  then
				isVisible = true
			else
				isVisible = false
			end
			btnPanel:setVisible(isVisible)
			unoperateTitle:setVisible(not isVisible)
			
			widget:setAnchorPoint(cc.p(0,0))
			widget:setTag(index)
			widget:addChild(memberNode)
			memberNode:setPosition(cc.p(0,0))
			memberNode:setTag(index)
			memberListView:pushBackCustomItem(widget)
		end
	end
	local listener = cc.EventListenerCustom:create("Update_MemberList", onUpdateMemberList)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	local function onOperateFamily()
		wd.showRichTips(4,"操作成功")
		if self.operatorLayer then
			self.operatorLayer:removeFromParent()
			self.operatorLayer = nil
			hidePanel:setVisible(false)
		end
		
		if self.tipsLayer then
			self.tipsLayer:removeFromParent()
			self.tipsLayer = nil
		end
		self.dataHandler:requestGetFamilyMemberList()
	end
	local listener = cc.EventListenerCustom:create("Operate_Family", onOperateFamily)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	local function onRemoveTips()
		if self.tipsLayer then
			self.tipsLayer = nil
		end
	end
	local listener = cc.EventListenerCustom:create("Remove_Tips", onRemoveTips)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	local function onRemoveOperate()
		if self.operatorLayer then
			self.operatorLayer = nil
		end
	end
	local listener = cc.EventListenerCustom:create("Remove_Operate", onRemoveOperate)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end

return Family_Member_ListLayer
