
local Family_Member_TempleLayer = class("Family_Member_TempleLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function Family_Member_TempleLayer.create()
    local layer = Family_Member_TempleLayer.new()
    layer:createLayerMenu()
    return layer
end

function Family_Member_TempleLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.dataHandler = wd.familyHandler 
	self.selectTag = 1
	self.timeSchedule = nil
	self.remainTimes = nil
	self.getCishu = nil
	self.myGift = nil
	self.status = false
	self.isGiftTrue = true
end

function Family_Member_TempleLayer:clear()
	if self.timeSchedule ~= nil then
        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.timeSchedule)
        self.timeSchedule = nil
    end
	self:removeFromParent()
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_ShopList")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Refresh_Family_Shop")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Buy_Family_Shop_Item")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_Welfare_View")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_Family_Gem")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Buy_Bat_Times")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_Family_Boss_Box")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Family_Battle_Init")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Family_Battle_Apply")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Family_Battle_Join")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Family_Battle_Get_Pay")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Family_Battle_Get_Date")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_FamilyAward")
end

function Family_Member_TempleLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/family/Family_Mine_Temple_Scene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)
	
    local backBtn = ccui.Helper:seekWidgetByName(node,"Close_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local event = cc.EventCustom:new("RemoveFamilyMineLayer")
				cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
				self:clear()
            end
        end
    )
	
	local infoBtn = ccui.Helper:seekWidgetByName(node,"Info_Button")
	infoBtn:setPressedActionEnabled(true)
    infoBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self.dataHandler:requestOpenFamily()
				local layerClass = require("src.game.family.Family_Member_InfoLayer")
                self:getParent().familyMineLayer = layerClass.create()
                self:getParent():addChild(self:getParent().familyMineLayer)
				self:clear()
            end
        end
    )
	
	local memberBtn = ccui.Helper:seekWidgetByName(node,"Member_Button")
	memberBtn:setPressedActionEnabled(true)
    memberBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self.dataHandler:requestGetFamilyMemberList()
				local layerClass = require("src.game.family.Family_Member_ListLayer")
                self:getParent().familyMineLayer = layerClass.create()
                self:getParent():addChild(self:getParent().familyMineLayer)
				self:clear()
            end
        end
    )
	
	
	
	local btnListView = tolua.cast(ccui.Helper:seekWidgetByName(node,"Button_ListView"), "ccui.ListView")

	self.contentPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Content_Panel"), "ccui.Widget")
	
	local function onBtnTouch(sender,eventType)
		if eventType == ccui.TouchEventType.ended then
			--if sender:getTag() > wd.familyTempleType.Shop then
			--	wd.showRichTips(4,"暂未开放")
			--else
				if self.selectTag == sender:getTag() then
					return
				end
				local lastBtn = btnListView:getChildByTag(self.selectTag)
				local curBtn = btnListView:getChildByTag(sender:getTag())
				lastBtn:setScale(1.0)
				curBtn:setScale(1.1)
				--wd.setSelectBox(btnListView,self.selectTag,sender:getTag())
				self.selectTag = sender:getTag()
				self:showSubView(sender:getTag())
			--end
		end
	end
	
	for i,v in ipairs(wd.familyTempleSubSprite) do
		local btn = ccui.Button:create("family_btn.png","family_btn.png", "", ccui.TextureResType.plistType)
		local btnNode = tolua.cast(cc.CSLoader:createNode("ui/family/Family_Temple_BtnNode.csb"),"ccui.Widget")
		local titleSprite = tolua.cast(btnNode:getChildByName("Button_Title"),"cc.Sprite")
		titleSprite:setSpriteFrame(v)
		btnNode:setTag(i)
		if i == 1 then
			btn:setScale(1.1)
		end
		btn:addChild(btnNode)
		btn:setAnchorPoint(cc.p(0.5,0.5))
		btn:setTag(i)
		btn:setScale9Enabled(true)
		btn:setContentSize(180,75)
		btn:addTouchEventListener(onBtnTouch)
		btnListView:pushBackCustomItem(btn)
	end
	
	---------------------------------------welfare-----------------------------------------------
	
	local function onUpdateWelfareView()
		self:updateWelfareView()
	end
	local listener = cc.EventListenerCustom:create("Update_Welfare_View", onUpdateWelfareView)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	local function onGetFamilyGem()
		wd.showRichTips(4,"领取成功")
		self.dataHandler:requestOpenFamilyCard()
	end
	local listener = cc.EventListenerCustom:create("Get_Family_Gem", onGetFamilyGem)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	---------------------------------------shop--------------------------------------------------
	local function onUpdateShowList()
		self:updateShopView()
	end
	local listener = cc.EventListenerCustom:create("Update_ShopList", onUpdateShowList)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	local function onRefreshFamilyShop()
		wd.showRichTips(4,"刷新成功")
		if self.refreshLayer then
			self.refreshLayer:removeFromParent()
			self.refreshLayer = nil
		end
		self.dataHandler:requestOpenFamilyShop()
	end
	local listener = cc.EventListenerCustom:create("Refresh_Family_Shop", onRefreshFamilyShop)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	local function onBuyFamilyShopItem()
		wd.showRichTips(4,"兑换成功")
		if self.exchangeLayer  then
			self.exchangeLayer:removeFromParent()
			self.exchangeLayer = nil
		end
		local node = self.contentPanel:getChildByTag(wd.familyTempleType.Shop)
		if node then
			local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Main_Panel"), "ccui.Widget") 
			local contributeLabel = tolua.cast(mainPanel:getChildByName("Contribute_Label"), "ccui.Text")
			contributeLabel:setString(wd.GlobalData:getInstance():getMyFamilyContribute())
		end
	end
	local listener = cc.EventListenerCustom:create("Buy_Family_Shop_Item", onBuyFamilyShopItem)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);

	---------------------------------------公会战---------------------------------------------
	-- familyBattle
	local function onOpenFamilyBattle(EventCustom)
		self:updateBattleView()
	end
	
	local listener = cc.EventListenerCustom:create("Family_Battle_Init", onOpenFamilyBattle)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
    local function onOpenFamilyBattleDate(EventCustom)
		local layerClass = require("src.game.family.family_War_Progress")
		local layer = layerClass.create()
		self:addChild(layer)
	end
	
	local listener = cc.EventListenerCustom:create("Family_Battle_Get_Date", onOpenFamilyBattleDate)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
    self:showSubView(wd.familyTempleType.Define)
end

function Family_Member_TempleLayer:showSubView(tag)
	if self.timeSchedule ~= nil then
        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.timeSchedule)
        self.timeSchedule = nil
    end
    cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Buy_Bat_Times")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_Family_Boss_Box")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Family_Battle_Apply")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Family_Battle_Join")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Family_Battle_Get_Pay")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_FamilyAward")

	self.contentPanel:removeAllChildren()
	if tag == wd.familyTempleType.Welfare then
		self.dataHandler:requestOpenFamilyCard() --发送请求
	elseif tag == wd.familyTempleType.Shop then
		self.dataHandler:requestOpenFamilyShop() --发送请求
	elseif tag == wd.familyTempleType.Define then
		self:updateGuardView()--家族守护
	elseif tag == wd.familyTempleType.Battle then
		--self:updateBattleView()--家族战
		self.dataHandler:requestfamilyBattleInit()
	end
end

-- welfare福利
function Family_Member_TempleLayer:updateWelfareView()
	self.contentPanel:removeAllChildren()
	local node = tolua.cast(cc.CSLoader:createNode("ui/family/Family_Temple_WelfareNode.csb"),"ccui.Widget")
	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Main_Panel"), "ccui.Widget") 
	mainPanel:setContentSize(self.contentPanel:getContentSize())
	ccui.Helper:doLayout(mainPanel)
	
	
	local helpBtn = tolua.cast(mainPanel:getChildByName("Help_Button"), "ccui.Button")
	helpBtn:setPressedActionEnabled(true)
    helpBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local layerClass = require("src.game.setting.HelpLayer")
				local layer = layerClass.create(wd.helpType.Sub,wd.helpTag.Welfare)
				self:addChild(layer)
            end
        end
    )
	
	local myFamilyCard = self.dataHandler:getMyFamilyCardInfo()
	
	local buyBtn = tolua.cast(mainPanel:getChildByName("Buy_Button"), "ccui.Button")
	local hadBuySprite = tolua.cast(mainPanel:getChildByName("Had_Buy_Sprite"), "cc.Sprite")

	--buyBtn:setVisible(not myFamilyCard.buyState)
	hadBuySprite:setVisible(myFamilyCard.buyState)
	if not myFamilyCard.buyState then
		buyBtn:addTouchEventListener(
			function(sender,eventType)
				if eventType == ccui.TouchEventType.ended then
					--print(type(myFamilyCard.cardLevel).."  "..myFamilyCard.cardLevel)
					
					local item = wd.GlobalData:getInstance():getChargeXmlData("family_card",myFamilyCard.cardLevel-1)
					if item ~= nil then
						if not wd.SdkApi:isTencentSdk() then
							wd.GlobalData:getInstance():setChargeData(item)
							wd.TranscodingSend:createOrder(item:getChargeCode(),item:getMoney())
						else
							wd.GlobalData:getInstance():setChargeData(item)
							wd.TranscodingSend:tencentPay()
						end
					else
						wd.showRichTips(4,"充值数据有误")
					end
					
					
				    --[[local item = wd.GlobalData:getInstance():getChargeXmlData("family_card",myFamilyCard.cardLevel-1)
				    local payDir = "http://wendingttlx.51vip.biz:"
					-- 购买 
					if item ~= nil then
						local role = wd.GlobalData:getInstance():getRoleData()
						local server = wd.GlobalData:getInstance():getGameServerForId(wd.GlobalData:getInstance():getAreaId())
						if server ~= nil and role ~= nil then
							local port = server:getPort()
							payDir = string.format("%s%d",payDir,port)
							print(payDir)
							wd.SdkApi:pay(item:getMoney(), server:getServerId(), server:getName(), role:getRoleId(), role:getName(), role:getLevel(),payDir, string.format("%d",item:getChargeCode()))
						end
					else
						wd.showRichTips(4,"充值数据有误")
					end--]]
				end
			end
		)
	end
		
	local nameLabel = tolua.cast(mainPanel:getChildByName("Name_Label"), "ccui.Text")
	nameLabel:setString(myFamilyCard.cardName)
	local allGetLabel = tolua.cast(mainPanel:getChildByName("Number_All_Label"), "ccui.Text")
	allGetLabel:setString(string.format("可领取:%d",myFamilyCard.allGem))
	local myselfGetLabel = tolua.cast(mainPanel:getChildByName("Number_Myself_Label"), "ccui.Text")
	myselfGetLabel:setString(string.format("可领取:%d",myFamilyCard.myGem))
	local priceLabel = tolua.cast(mainPanel:getChildByName("Price_Label"), "ccui.Text")
	priceLabel:setString(string.format("%d元",myFamilyCard.cardLevel*10))
	local infoLabel = tolua.cast(mainPanel:getChildByName("Info_Label"), "ccui.Text")
	infoLabel:setString(string.format("购买后可立即获得%d元宝,连续每天可领取%d元宝",myFamilyCard.cardLevel*100,myFamilyCard.cardLevel*10))
	
	local getAllBtn = tolua.cast(mainPanel:getChildByName("Get_All_Button"), "ccui.Button")
	local getAllUnoperateSprite = tolua.cast(mainPanel:getChildByName("Get_All_Unoperate_Sprite"), "cc.Sprite")
	if not myFamilyCard.allgetState then
		getAllBtn:addTouchEventListener(
			function(sender,eventType)
				if eventType == ccui.TouchEventType.ended then
					-- 全家族人员领取
					self.dataHandler:requestGetFamilyGem(true)
				end
			end
		)
	end
	
	
	local getMyselfBtn = tolua.cast(mainPanel:getChildByName("Get_Myself_Button"), "ccui.Button")
	local getMyUnoperateSprite = tolua.cast(mainPanel:getChildByName("Get_Myself_Unoperate_Sprite"), "cc.Sprite")
	if not myFamilyCard.myGetState then
		getMyselfBtn:addTouchEventListener(
			function(sender,eventType)
				if eventType == ccui.TouchEventType.ended then
					-- 自己购买后领取
					self.dataHandler:requestGetFamilyGem(false)
				end
			end
		)
	end
	local allFlag,myFlag
	if myFamilyCard.allgetState then
		allFlag = false
	else
		allFlag = true
	end
	if myFamilyCard.buyState then
		
		if myFamilyCard.myGetState then
			myFlag = false
		else
			myFlag = true
		end
	else
		--allFlag = true
		myFlag = true
	end
	
	getAllBtn:setVisible(allFlag)
	getAllUnoperateSprite:setVisible(not allFlag)
	getMyselfBtn:setVisible(myFlag)
	getMyUnoperateSprite:setVisible(not myFlag)
	
	local showTipsBtn = tolua.cast(mainPanel:getChildByName("Show_BuyTips_Button"), "ccui.Button")
	local tipsBox = tolua.cast(showTipsBtn:getChildByName("Tips_Box"), "cc.Sprite")
	local tipScroll =  tolua.cast(tipsBox:getChildByName("Tips_ScrollView"), "ccui.ScrollView")
	local buyerNameList = self.dataHandler:getBuyerNameList()
	local widget = ccui.Widget:create()
	local height = 0
	for i,v in ipairs(buyerNameList) do
		local label = cc.Label:create()
		label:setSystemFontSize(18)
		label:setWidth(tipScroll:getContentSize().width)
		label:setString(v.." (已购买)")
		label:setAnchorPoint(cc.p(0,1))
		widget:addChild(label)
		label:setPosition(5,-(i-1)*18)
		height = height +18
	end
	tipScroll:setInnerContainerSize(cc.size(tipScroll:getContentSize().width,height))
	tipScroll:addChild(widget)
	widget:setPosition(0,tipScroll:getInnerContainerSize().height)
	tipScroll:jumpToTop()
	
    showTipsBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				tipsBox:setVisible(not tipsBox:isVisible())
            end
        end
    )
	
	
	self.contentPanel:addChild(node)
	node:setTag(wd.familyTempleType.Welfare)
	node:setPosition(0,0)
end

-- shop
function Family_Member_TempleLayer:updateShopView()
	self.contentPanel:removeAllChildren()
	local node = tolua.cast(cc.CSLoader:createNode("ui/family/Family_Temple_ShopNode.csb"),"ccui.Widget")
	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Main_Panel"), "ccui.Widget") 
	mainPanel:setContentSize(self.contentPanel:getContentSize())
	ccui.Helper:doLayout(mainPanel)
	local contributeLabel = tolua.cast(mainPanel:getChildByName("Contribute_Label"), "ccui.Text")
	contributeLabel:setString(self.dataHandler:getMyContribute())
	
	local refreshBtn = tolua.cast(mainPanel:getChildByName("Refresh_Button"), "ccui.Button")
    refreshBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.family.Family_MessageBox_Layer")
				local msg = {}
				table.insert(msg,"是否花 ")
				table.insert(msg,string.format("{n=[%s]}",tostring(20)))
				table.insert(msg," 元宝立刻刷新商店")
				local function refresh()
					self.dataHandler:requestRefreshFamilyShop()
				end
				self.refreshLayer = layerClass.create("family_subtitle_refresh.png",msg,refresh)
				self:addChild(self.refreshLayer)
            end
        end
    )
	
	local showList = self.dataHandler:getFamilyShopShowList()	
	local itemScroll = tolua.cast(mainPanel:getChildByName("Item_ScrollView"), "ccui.ScrollView")
	itemScroll:removeAllChildren()
	local familyLevel = self.dataHandler:getMyFamilyLevel()
	
	local distance = (itemScroll:getContentSize().width - 314*2)/3
	self.itemNodeSize = cc.size(314*2+distance,170)
	self.gap = 10
	self.leftNodePosX = distance
	self.rightNodePosX = distance*2+314
	
	local itemCount = #showList
	local nodeCount = 0
	if itemCount%2 == 0 then
		nodeCount = itemCount/2
	elseif itemCount%2 == 1 then
		nodeCount =(itemCount+1)/2
	end
	if nodeCount ~= 0 then
		itemScroll:setInnerContainerSize(cc.size(self.itemNodeSize.width,self.itemNodeSize.height*nodeCount+10*(nodeCount+1)))
	end
	if itemCount > 0 then
		local tag = 0
		local posTag = 0
		for i = 0,itemCount-1 do
			if i%2 == 0 then
				tag = i/2+1
				posTag = 0
			elseif i%2 == 1 then
				tag = math.floor(i/2) + 1
				posTag = 1
			end
			local mallItem = showList[i+1]
			local itemInfo = mallItem.itemInfo
			local item = itemInfo.item
			
			local function mallBtn(sender,eventType)
				if eventType == ccui.TouchEventType.ended then
					local layerClass = require("src.game.family.Family_MessageBox_Layer")
					local msg = {}
					table.insert(msg,"兑换")
					table.insert(msg,string.format("{n=[%s]}",item:getName()))
					table.insert(msg,string.format("需要消耗%d贡献值，是否兑换",mallItem.contribute))
					local function exchange()
						self.dataHandler:requestBuyShopItem(mallItem.id)
					end
					self.exchangeLayer = layerClass.create("family_subtitle_exchange.png",msg,exchange)
					self:addChild(self.exchangeLayer)
				end
			end
			local btn = ccui.Button:create("package_subbox.png", "package_subbox.png", "", ccui.TextureResType.plistType)
			btn:setTag(i)
			local itemNode = tolua.cast(cc.CSLoader:createNode("ui/family/Family_Shop_ItemNode.csb"),"ccui.Widget")
			local lockSprite = tolua.cast(itemNode:getChildByName("Lock_Sprite"), "cc.Sprite")
			local contentPanel =  tolua.cast(itemNode:getChildByName("Content_Panel"), "ccui.Widget")
			local lockOpenLabel = tolua.cast(lockSprite:getChildByName("Open_Label"), "ccui.Text")
			local lockInfoLabel = tolua.cast(lockSprite:getChildByName("Info_Label"), "ccui.Text")
			btn:setAnchorPoint(cc.p(0,0))
			btn:addChild(itemNode)
			
			if familyLevel >= i+1 then
				btn:addTouchEventListener(mallBtn)
				lockSprite:setVisible(false)
				contentPanel:setVisible(true)
				contentPanel:setSwallowTouches(false)
				local icon = tolua.cast(contentPanel:getChildByName("Tools_Sprite"), "cc.Sprite")
				icon:setSpriteFrame(string.format("%d.png",itemInfo.itemId))
				icon:setVisible(true)
				
				local color = tolua.cast(contentPanel:getChildByName("Color_Sprite"), "cc.Sprite")
				if itemInfo.itemType == wd.ItemType.Tools then
					color:setSpriteFrame(string.format("%02d.png",item:getQuality()))
					if item:getQuality() == 5 then
						wd.itemEffect(image)
					end
				elseif itemInfo.itemType == wd.ItemType.Equip then
					color:setSpriteFrame(string.format("%02d.png",5))
				end
				
				
				local nameLabel = tolua.cast(contentPanel:getChildByName("Name_Label"), "ccui.Text")
				nameLabel:setString(item:getName())
				
				local numberLabel =  tolua.cast(contentPanel:getChildByName("Number_Label"), "ccui.Text")
				numberLabel:setString(itemInfo.itemCount)
				
				local priceLabel = tolua.cast(contentPanel:getChildByName("Cost_Label"), "ccui.Text")
				priceLabel:setString(string.format("%d",mallItem.contribute))
				
				local iconBtn = tolua.cast(contentPanel:getChildByName("Item_Button"), "ccui.Button")
				iconBtn:addTouchEventListener(
					function(sender,eventType)
						if eventType == ccui.TouchEventType.ended then
							if itemInfo.itemType == wd.ItemType.Tools then
								local layerClass =  require("src.game.package.ToolsTipsLayer")
								local layer = layerClass.create()
								layer:createLayerMenu(itemInfo.itemId, true)
								self:addChild(layer)
							elseif itemInfo.itemType == wd.ItemType.Equip then
								local layerClass = require("src.game.shop.ArtifactTipsLayer")
								local layer = layerClass.create()
								layer:createLayerMenu(item)
								self:addChild(layer)
							end
						end
					end
				)
			else
				lockSprite:setVisible(true)
				contentPanel:setVisible(false)
				lockOpenLabel:setString(wd.familyLockOpenInfo[i+1])
				lockInfoLabel:setString(wd.familyLockInfo[i+1])
			end
			itemScroll:addChild(btn)
			if posTag == 0 then
				btn:setPosition(self.leftNodePosX,itemScroll:getInnerContainerSize().height - self.gap - tag*(self.itemNodeSize.height+self.gap))
			else
				btn:setPosition(self.rightNodePosX,itemScroll:getInnerContainerSize().height - self.gap - tag*(self.itemNodeSize.height+self.gap))
			end
		end
	end
	itemScroll:jumpToTop()
	self.contentPanel:addChild(node)
	node:setTag(wd.familyTempleType.Shop)
	node:setPosition(0,0)
end

-- 家族守护
function Family_Member_TempleLayer:updateGuardView()
	self.contentPanel:removeAllChildren()

	local myFamily = wd.GlobalData:getInstance():getMyFamilyItem()
	local roldGuard = wd.GlobalData:getInstance():getRoleGuardInfo()

	
	local node = tolua.cast(cc.CSLoader:createNode("ui/familyGuard/familyGuard_main.csb"),"ccui.Widget")
	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Main_Panel"), "ccui.Widget") 
	mainPanel:setContentSize(self.contentPanel:getContentSize())
	ccui.Helper:doLayout(mainPanel)

	
	self.getCishu = roldGuard:getCishu()
	self.remainTimes = roldGuard:getBuyCishu()
	self.myGift = roldGuard:getGift()

	local cishu = tolua.cast(ccui.Helper:seekWidgetByName(node,"Number_Label"), "ccui.Text")
	cishu:setString(self.getCishu)

	local addBtn =  tolua.cast(ccui.Helper:seekWidgetByName(node,"Add_Button"), "ccui.Button")
	addBtn:setPressedActionEnabled(true)
	addBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local layerClass = require("src.game.family.Family_MessageBox_Layer")
				local msg = {}
				table.insert(msg,"是否花 ")
				table.insert(msg,string.format("{n=[%s]}",tostring(20*(self.remainTimes+1))))
				table.insert(msg," 元宝购买 ")
				table.insert(msg,string.format("{n=[%s]}",tostring(1)))
				table.insert(msg," 次挑战次数")
				local function buyNumber()
					self.dataHandler:requestBuyCishu()
				end
				self.tipsLayer = layerClass.create("boss_subtitle_buycount.png",msg,buyNumber)
				self:addChild(self.tipsLayer)
            end
        end
    )

	local function buyBatTimesCallBack(EventCustom)
		if self.tipsLayer ~= nil then
			wd.showRichTips(4,"购买成功")
			self.tipsLayer:removeFromParent()
			self.tipsLayer = nil
			self.remainTimes = self.remainTimes + 1
			self.getCishu = self.getCishu + 1
			cishu:setString(self.getCishu)
		end
	end
	local listener = cc.EventListenerCustom:create("Buy_Bat_Times", buyBatTimesCallBack)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);

 
    local function getFamilyBossBoxCallBack(EventCustom)
		wd.showRichTips(4,"领取成功")
		mainPanel:getChildByName("Get_All_Unoperate_Sprite"):setVisible(true)
		self.status = true
	end
	local listener = cc.EventListenerCustom:create("Get_Family_Boss_Box", getFamilyBossBoxCallBack)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);


	local helpBtn = tolua.cast(mainPanel:getChildByName("Help_Button"), "ccui.Button")
	helpBtn:setPressedActionEnabled(true)
	helpBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local layerClass = require("src.game.setting.HelpLayer")
				local layer = layerClass.create(wd.helpType.Sub,wd.helpTag.FamilyGurade)
				self:addChild(layer)
            end
        end
    )


	local myFamilyLevel = myFamily:getLevel()
	local BossId1 = wd.GlobalData:getInstance():getFamilyBoss1IdByLevel(myFamilyLevel)
	local BossId2 = wd.GlobalData:getInstance():getFamilyBoss2IdByLevel(myFamilyLevel)
	local BossId3 = wd.GlobalData:getInstance():getFamilyBoss3IdByLevel(myFamilyLevel)
	local BossId4 = wd.GlobalData:getInstance():getFamilyBoss4IdByLevel(myFamilyLevel)
	local BossId5 = wd.GlobalData:getInstance():getFamilyBoss5IdByLevel(myFamilyLevel)

	local Boss1NameLabel = tolua.cast(mainPanel:getChildByName("Boss_one"):getChildByName("Name_Label"), "ccui.Text")
	local Boss2NameLabel = tolua.cast(mainPanel:getChildByName("Boss_two"):getChildByName("Name_Label"), "ccui.Text")
	local Boss3NameLabel = tolua.cast(mainPanel:getChildByName("Boss_three"):getChildByName("Name_Label"), "ccui.Text")
	local Boss4NameLabel = tolua.cast(mainPanel:getChildByName("Boss_four"):getChildByName("Name_Label"), "ccui.Text")
	local Boss5NameLabel = tolua.cast(mainPanel:getChildByName("Boss_five"):getChildByName("Name_Label"), "ccui.Text")

	local Boss1LvLabel = tolua.cast(mainPanel:getChildByName("Boss_one"):getChildByName("Level_Label"), "ccui.TextBMFont")
	local Boss2LvLabel = tolua.cast(mainPanel:getChildByName("Boss_two"):getChildByName("Level_Label"), "ccui.TextBMFont")
	local Boss3LvLabel = tolua.cast(mainPanel:getChildByName("Boss_three"):getChildByName("Level_Label"), "ccui.TextBMFont")
	local Boss4LvLabel = tolua.cast(mainPanel:getChildByName("Boss_four"):getChildByName("Level_Label"), "ccui.TextBMFont")
	local Boss5LvLabel = tolua.cast(mainPanel:getChildByName("Boss_five"):getChildByName("Level_Label"), "ccui.TextBMFont")

	local Boss1Btn = mainPanel:getChildByName("Boss_one"):getChildByName("Boss_Button")
	local Boss2Btn = mainPanel:getChildByName("Boss_two"):getChildByName("Boss_Button")
	local Boss3Btn = mainPanel:getChildByName("Boss_three"):getChildByName("Boss_Button")
	local Boss4Btn = mainPanel:getChildByName("Boss_four"):getChildByName("Boss_Button")
	local Boss5Btn = mainPanel:getChildByName("Boss_five"):getChildByName("Boss_Button")

	local BOSS_HP1 = mainPanel:getChildByName("Text_number_1")
	local BOSS_HP2 = mainPanel:getChildByName("Text_number_2")
	local BOSS_HP3 = mainPanel:getChildByName("Text_number_3")
	local BOSS_HP4 = mainPanel:getChildByName("Text_number_4")
	local BOSS_HP5 = mainPanel:getChildByName("Text_number_5")
	local BOSS_HP_Str1 = 0
	local BOSS_HP_Str2 = 0
	local BOSS_HP_Str3 = 0
	local BOSS_HP_Str4 = 0
	local BOSS_HP_Str5 = 0

	local familyConfig = wd.GlobalData:getInstance():getFamilyConfigInXml(myFamilyLevel-1)
	local function getItemListCallBack(dropStr)
		local awardList = {}
		local id,itemCount,type,startIndex,endIndex
		local str = dropStr
		while(str ~= "")
		do
			local item = {}
			startIndex,endIndex,type,id,itemCount = string.find(str,"(%d)#(%d+)|(%d+)")
			item.id = tonumber(id)
			item.itemCount = tonumber(itemCount)
			item.type = tonumber(type)
			table.insert(awardList,item)
			str = string.sub(str,endIndex+2,-1)
		end
		return awardList
	end

	local baoxiang =  mainPanel:getChildByName("Button_baoxiang")
	if self.myGift == 1 then
		mainPanel:getChildByName("Get_All_Unoperate_Sprite"):setVisible(true)
	else
		baoxiang:addTouchEventListener(
	        function(sender,eventType)
	            if eventType == ccui.TouchEventType.ended then
	            	if self.status == true then
	            		wd.showRichTips(4,"已经领取过了")
	            	else
		            	--if myFamily:getBoxStatus() == 1 then
							--显示宝箱内容
							local layerClass = require("src.game.family.Family_Guard_Box")
							local layer = layerClass.create()
							layer:createLayerMenu(1,getItemListCallBack(familyConfig:getPackageString()),myFamily:getBoxStatus())
							self:addChild(layer)
						--else
						--	wd.showRichTips(4,"请先完成所有挑战")
						--end
					end

	            end
	        end
	    )
	end
	
	for i=0,35 do
		local familyBossItem = wd.GlobalData:getInstance():getFamilyBossItemInXml(i)
		if familyBossItem ~=nil then
			if familyBossItem:getBossId() == BossId1 then
				Boss1NameLabel:setString(familyBossItem:getName())
				Boss1LvLabel:setString(string.format("Lv %d",familyBossItem:getLevel()))
				if myFamily:getBossId() == 1 and myFamily:getBoxStatus() ~= 1 then
					BOSS_HP_Str1 = familyBossItem:getHp()
					if myFamily:getBossBlood() == 0 then
						BOSS_HP1:setString("100%")
					else
						BOSS_HP1:setString(math.ceil((myFamily:getBossBlood()/familyBossItem:getHp())*100) .. "%")
					end
				end

			elseif familyBossItem:getBossId() == BossId2 then
				Boss2NameLabel:setString(familyBossItem:getName())
				Boss2LvLabel:setString(string.format("Lv %d",familyBossItem:getLevel()))
				if myFamily:getBossId() == 2 and myFamily:getBoxStatus() ~= 1 then
					BOSS_HP_Str2 = familyBossItem:getHp()
					if myFamily:getBossBlood() == 0 then
						BOSS_HP2:setString("100%")
					else
						BOSS_HP2:setString(math.ceil((myFamily:getBossBlood()/familyBossItem:getHp())*100) .. "%")
					end
				end
			elseif familyBossItem:getBossId() == BossId3 then
				Boss3NameLabel:setString(familyBossItem:getName())
				Boss3LvLabel:setString(string.format("Lv %d",familyBossItem:getLevel()))
				if myFamily:getBossId() == 3 and myFamily:getBoxStatus() ~= 1 then
					BOSS_HP_Str3 = familyBossItem:getHp()
					if myFamily:getBossBlood() == 0 then
						BOSS_HP3:setString("100%")
					else
						BOSS_HP3:setString(math.ceil((myFamily:getBossBlood()/familyBossItem:getHp())*100) .. "%")
					end
				end
			elseif familyBossItem:getBossId() == BossId4 then
				Boss4NameLabel:setString(familyBossItem:getName())
				Boss4LvLabel:setString(string.format("Lv %d",familyBossItem:getLevel()))
				if myFamily:getBossId() == 4 and myFamily:getBoxStatus() ~= 1 then
					BOSS_HP_Str4 = familyBossItem:getHp()
					if myFamily:getBossBlood() == 0 then
						BOSS_HP4:setString("100%")
					else
						BOSS_HP4:setString(math.ceil((myFamily:getBossBlood()/familyBossItem:getHp())*100) .. "%")
					end
				end
			elseif familyBossItem:getBossId() == BossId5 then
				Boss5NameLabel:setString(familyBossItem:getName())
				Boss5LvLabel:setString(string.format("Lv %d",familyBossItem:getLevel()))
				if myFamily:getBossId() == 5 and myFamily:getBoxStatus() ~= 1 then
					BOSS_HP_Str5 = familyBossItem:getHp()
					if myFamily:getBossBlood() == 0 then
						BOSS_HP5:setString("100%")
					else
						BOSS_HP5:setString(math.ceil((myFamily:getBossBlood()/familyBossItem:getHp())*100) .. "%")
					end
				end
			end
		end
	end

	if myFamily:getBoxStatus() == 1 then
		mainPanel:getChildByName("Boss_one"):getChildByName("Image_over_1"):setVisible(true);
		mainPanel:getChildByName("Boss_two"):getChildByName("Boss_Lock"):setVisible(false);
		mainPanel:getChildByName("Boss_two"):getChildByName("Image_over_2"):setVisible(true);
		mainPanel:getChildByName("Boss_three"):getChildByName("Boss_Lock"):setVisible(false);
		mainPanel:getChildByName("Boss_three"):getChildByName("Image_over_3"):setVisible(true);
		mainPanel:getChildByName("Boss_four"):getChildByName("Boss_Lock"):setVisible(false);
		mainPanel:getChildByName("Boss_four"):getChildByName("Image_over_4"):setVisible(true);
		mainPanel:getChildByName("Boss_five"):getChildByName("Boss_Lock"):setVisible(false);
		mainPanel:getChildByName("Boss_five"):getChildByName("Image_over_5"):setVisible(true);
	else
		if myFamily:getBossId() == 1 then
			
		elseif myFamily:getBossId() == 2 then
			mainPanel:getChildByName("Boss_one"):getChildByName("Image_over_1"):setVisible(true);
            mainPanel:getChildByName("Boss_one"):getChildByName("Boss_Lock_bg"):setVisible(true);
			mainPanel:getChildByName("Boss_one"):getChildByName("Boss_Button"):setVisible(false);
			mainPanel:getChildByName("Boss_two"):getChildByName("Boss_Button"):setVisible(true);
			mainPanel:getChildByName("Boss_two"):getChildByName("Boss_Lock_bg"):setVisible(false);
			mainPanel:getChildByName("Boss_two"):getChildByName("Boss_Lock"):setVisible(false);
			
		elseif myFamily:getBossId() == 3 then
			mainPanel:getChildByName("Boss_one"):getChildByName("Image_over_1"):setVisible(true);
            mainPanel:getChildByName("Boss_one"):getChildByName("Boss_Lock_bg"):setVisible(true);
			mainPanel:getChildByName("Boss_one"):getChildByName("Boss_Button"):setVisible(false);
			mainPanel:getChildByName("Boss_two"):getChildByName("Boss_Lock"):setVisible(false);
			mainPanel:getChildByName("Boss_two"):getChildByName("Image_over_2"):setVisible(true);
			mainPanel:getChildByName("Boss_three"):getChildByName("Boss_Lock_bg"):setVisible(false);
			mainPanel:getChildByName("Boss_three"):getChildByName("Boss_Lock"):setVisible(false);
            mainPanel:getChildByName("Boss_three"):getChildByName("Boss_Button"):setVisible(true);
            
		elseif myFamily:getBossId() == 4 then
			mainPanel:getChildByName("Boss_one"):getChildByName("Image_over_1"):setVisible(true);
            mainPanel:getChildByName("Boss_one"):getChildByName("Boss_Lock_bg"):setVisible(true);
			mainPanel:getChildByName("Boss_one"):getChildByName("Boss_Button"):setVisible(false);
			mainPanel:getChildByName("Boss_two"):getChildByName("Boss_Lock"):setVisible(false);
			mainPanel:getChildByName("Boss_two"):getChildByName("Image_over_2"):setVisible(true);
			mainPanel:getChildByName("Boss_three"):getChildByName("Boss_Lock"):setVisible(false);
			mainPanel:getChildByName("Boss_three"):getChildByName("Image_over_3"):setVisible(true);
			mainPanel:getChildByName("Boss_four"):getChildByName("Boss_Lock_bg"):setVisible(false);
			mainPanel:getChildByName("Boss_four"):getChildByName("Boss_Lock"):setVisible(false);
			mainPanel:getChildByName("Boss_four"):getChildByName("Boss_Button"):setVisible(true);
		elseif myFamily:getBossId() == 5 then
			mainPanel:getChildByName("Boss_one"):getChildByName("Image_over_1"):setVisible(true);
            mainPanel:getChildByName("Boss_one"):getChildByName("Boss_Lock_bg"):setVisible(true);
			mainPanel:getChildByName("Boss_one"):getChildByName("Boss_Button"):setVisible(false);
			mainPanel:getChildByName("Boss_two"):getChildByName("Boss_Lock"):setVisible(false);
			mainPanel:getChildByName("Boss_two"):getChildByName("Image_over_2"):setVisible(true);
			mainPanel:getChildByName("Boss_three"):getChildByName("Boss_Lock"):setVisible(false);
			mainPanel:getChildByName("Boss_three"):getChildByName("Image_over_3"):setVisible(true);
			mainPanel:getChildByName("Boss_four"):getChildByName("Boss_Lock"):setVisible(false);
			mainPanel:getChildByName("Boss_four"):getChildByName("Image_over_4"):setVisible(true);
			mainPanel:getChildByName("Boss_five"):getChildByName("Boss_Lock_bg"):setVisible(false);
			mainPanel:getChildByName("Boss_five"):getChildByName("Boss_Lock"):setVisible(false);
			mainPanel:getChildByName("Boss_five"):getChildByName("Boss_Button"):setVisible(true);
		end

		Boss1Btn:addTouchEventListener(
	        function(sender,eventType)
	            if eventType == ccui.TouchEventType.ended then
					if myFamily:getBossId() == 1 then
						--弹窗
						if self.getCishu > 0 then
							local layerClass = require("src.game.family.Family_Guard_Tip")
							local layer = layerClass.create()
							layer:createLayerMenu(1,familyConfig:getContribution(),Boss1NameLabel:getString(),Boss1LvLabel:getString(),BOSS_HP_Str1)
							self:addChild(layer)
						else
							wd.showRichTips(4,"挑战次数不足")
						end
					end
	            end
	        end
	    )

	    Boss2Btn:addTouchEventListener(
	        function(sender,eventType)
	            if eventType == ccui.TouchEventType.ended then
					if myFamily:getBossId() == 1 then
						wd.showRichTips(4,string.format("请先战胜第%d个Boss",1))
					elseif myFamily:getBossId() == 2 then
						--弹窗
						if self.getCishu > 0 then
							local layerClass = require("src.game.family.Family_Guard_Tip")
							local layer = layerClass.create()
							layer:createLayerMenu(2,familyConfig:getContribution(),Boss2NameLabel:getString(),Boss2LvLabel:getString(),BOSS_HP_Str2)
							self:addChild(layer)
						else
							wd.showRichTips(4,"挑战次数不足")
						end
					end
	            end
	        end
	    )

	    Boss3Btn:addTouchEventListener(
	        function(sender,eventType)
	            if eventType == ccui.TouchEventType.ended then
					if myFamily:getBossId() == 1 or myFamily:getBossId() == 2 then
						wd.showRichTips(4,string.format("请先战胜第%d个Boss",myFamily:getBossId()))
					elseif myFamily:getBossId() == 3 then
						--弹窗
						if self.getCishu > 0 then
							local layerClass = require("src.game.family.Family_Guard_Tip")
							local layer = layerClass.create()
							layer:createLayerMenu(3,familyConfig:getContribution(),Boss3NameLabel:getString(),Boss3LvLabel:getString(),BOSS_HP_Str3)
							self:addChild(layer)
						else
							wd.showRichTips(4,"挑战次数不足")
						end
					end
	            end
	        end
	    )

	    Boss4Btn:addTouchEventListener(
	        function(sender,eventType)
	            if eventType == ccui.TouchEventType.ended then
					if myFamily:getBossId() == 1 or myFamily:getBossId() == 2 or myFamily:getBossId() == 3 then
						wd.showRichTips(4,string.format("请先战胜第%d个Boss",myFamily:getBossId()))
					elseif myFamily:getBossId() == 4 then
						--弹窗
						if self.getCishu > 0 then
							local layerClass = require("src.game.family.Family_Guard_Tip")
							local layer = layerClass.create()
							layer:createLayerMenu(4,familyConfig:getContribution(),Boss4NameLabel:getString(),Boss4LvLabel:getString(),BOSS_HP_Str4)
							self:addChild(layer)
						else
							wd.showRichTips(4,"挑战次数不足")
						end
					end
	            end
	        end
	    )

	    Boss5Btn:addTouchEventListener(
	        function(sender,eventType)
	            if eventType == ccui.TouchEventType.ended then
					if myFamily:getBossId() == 1 or myFamily:getBossId() == 2 or myFamily:getBossId() == 3 or myFamily:getBossId() == 4 then
						wd.showRichTips(4,string.format("请先战胜第%d个Boss",myFamily:getBossId()))
					elseif myFamily:getBossId() == 5 then
						--弹窗
						if self.getCishu > 0 then
							local layerClass = require("src.game.family.Family_Guard_Tip")
							local layer = layerClass.create()
							layer:createLayerMenu(5,familyConfig:getContribution(),Boss5NameLabel:getString(),Boss5LvLabel:getString(),BOSS_HP_Str5)
							self:addChild(layer)
						else
							wd.showRichTips(4,"挑战次数不足")
						end
					end
	            end
	        end
	    )

	end

	self.contentPanel:addChild(node)

	node:setPosition(0,0)
	
end

-- 公会战
function Family_Member_TempleLayer:updateBattleView()
	self.contentPanel:removeAllChildren()
	local myFamilyBattle = wd.GlobalData:getInstance():getFamilyBattleItemInfo()
    local myFamilyTime = wd.GlobalData:getInstance():getFamilyBattleTime()
    local myFamily = wd.GlobalData:getInstance():getMyFamilyItem()
    local myFamilyGuard = wd.GlobalData:getInstance():getRoleGuardInfo()

	local node = tolua.cast(cc.CSLoader:createNode("ui/familyWar/FamilyWar_main.csb"),"ccui.Widget")
	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Main_Panel"), "ccui.Widget") 
	mainPanel:setContentSize(self.contentPanel:getContentSize())
	ccui.Helper:doLayout(mainPanel)
	local helpBtn = tolua.cast(mainPanel:getChildByName("Button_explain"), "ccui.Button")
	helpBtn:setPressedActionEnabled(true)

	helpBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local layerClass = require("src.game.setting.HelpLayer")
				local layer = layerClass.create(wd.helpType.Sub,wd.helpTag.FamilyBat)
				--local layer = layerClass.create(wd.helpType.Sub,6)
				self:addChild(layer)
            end
        end
    )

	-----------------------------------------------族长报名按钮----------------------------------------------------

	local Button_apply1 = tolua.cast(mainPanel:getChildByName("Button_apply1"), "ccui.Button")
	local Button_apply2 = tolua.cast(mainPanel:getChildByName("Button_apply2"), "ccui.Button")
	local Button_apply3 = tolua.cast(mainPanel:getChildByName("Button_apply3"), "ccui.Button")

	local Button_apply = {
		Button_apply1,
		Button_apply2,
		Button_apply3
	}


	-----------------------------------------------参战按钮-----------------------------------------------

	local Button_join1 = tolua.cast(mainPanel:getChildByName("Button_join1"), "ccui.Button")
	local Button_join2 = tolua.cast(mainPanel:getChildByName("Button_join2"), "ccui.Button")
	local Button_join3 = tolua.cast(mainPanel:getChildByName("Button_join3"), "ccui.Button")

	local Button_join = {
		Button_join1,
		Button_join2,
		Button_join3
	}

	-----------------------------------------------已报名参战图片-----------------------------------------------

	local Image_over1 = mainPanel:getChildByName("Image_over1")
	local Image_over2 = mainPanel:getChildByName("Image_over2")
	local Image_over3 = mainPanel:getChildByName("Image_over3")

	local Image_over = {
		Image_over1,
		Image_over2,
		Image_over3
	}

	
	-----------------------------------------------放大镜-----------------------------------------------

	local Button_quick1 = tolua.cast(mainPanel:getChildByName("Button_quick1"), "ccui.Button")
	local Button_quick2 = tolua.cast(mainPanel:getChildByName("Button_quick2"), "ccui.Button")
	local Button_quick3 = tolua.cast(mainPanel:getChildByName("Button_quick3"), "ccui.Button")

	local Button_quick = {
		Button_quick1,
		Button_quick2,
		Button_quick3
	}
	
	mainPanel:addTouchEventListener(
	function(sender,eventType)
		if eventType == ccui.TouchEventType.ended then
			for i=1 , 3 do
				if Button_quick[i]:getChildByName("Tips_Box" .. i):isVisible() == true then
					Button_quick[i]:getChildByName("Tips_Box" .. i):setVisible(false)
				end
			end
		end
	end
	)

	
	-----------------------------------------------占领家族文字-----------------------------------------------

	local Text_zhanling1 = tolua.cast(mainPanel:getChildByName("Text_zhanling1"), "ccui.Text")
	local Text_zhanling2 = tolua.cast(mainPanel:getChildByName("Text_zhanling2"), "ccui.Text")
	local Text_zhanling3 = tolua.cast(mainPanel:getChildByName("Text_zhanling3"), "ccui.Text")

	local Text_zhanling = {
		Text_zhanling1,
		Text_zhanling2,
		Text_zhanling3
	}

	-----------------------------------------------领取工资按钮-----------------------------------------------

	local get_Button1 = tolua.cast(mainPanel:getChildByName("get_Button1"), "ccui.Button")
	local get_Button2 = tolua.cast(mainPanel:getChildByName("get_Button2"), "ccui.Button")
	local get_Button3 = tolua.cast(mainPanel:getChildByName("get_Button3"), "ccui.Button")

	local get_Button = {
		get_Button1,
		get_Button2,
		get_Button3
	}

	-----------------------------------------------战斗光效-----------------------------------------------

	local effict_Button1 = mainPanel:getChildByName("Button_city1"):getChildByName("Arena_Effect1")
	local effict_Button2 = mainPanel:getChildByName("Button_city2"):getChildByName("Arena_Effect2")
	local effict_Button3 = mainPanel:getChildByName("Button_city3"):getChildByName("Arena_Effect3")

	local effict_Button = {
		effict_Button1,
		effict_Button2,
		effict_Button3
	}


	-----------------------------------------------已领取-----------------------------------------------

	local overButton1 = mainPanel:getChildByName("Get_All_1")
	local overButton2 = mainPanel:getChildByName("Get_All_2")
	local overButton3 = mainPanel:getChildByName("Get_All_3")

	local overButton = {
		overButton1,
		overButton2,
		overButton3
	}

	------------------------------------------------代码段-----------------------------------------------------

	local stageText = tolua.cast(mainPanel:getChildByName("stage_label"), "ccui.Text")
	local timeText = tolua.cast(mainPanel:getChildByName("time_label"), "ccui.Text")

	local battleProgress = tolua.cast(mainPanel:getChildByName("Button_zhankuang"), "ccui.Button")
	battleProgress:setPressedActionEnabled(true)


	------------------------------------------------增加消息回调------------------------------------------------

	local myCity = myFamily:getFightCityId()
	local whichity = nil
	local function FamilyBattleApplyCallBack(EventCustom) --城战报名
		wd.showRichTips(4,"报名成功")
		myCity = whichity 
		for i = 1,3 do
			Button_apply[i]:setVisible(false)
			Image_over[whichity]:setVisible(true)
		end
	end
	local listener = cc.EventListenerCustom:create("Family_Battle_Apply", FamilyBattleApplyCallBack)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);


    local function FamilyBattleJoinCallBack(EventCustom) --加入城战
		wd.showRichTips(4,"加入成功")
		for i = 1,3 do
			Button_join[i]:setVisible(false)
		end
		Image_over[myCity]:setVisible(true)
	end
	local listener = cc.EventListenerCustom:create("Family_Battle_Join", FamilyBattleJoinCallBack)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);

    local function FamilyBattleGetPayCallBack(EventCustom) --领取工资
		--wd.showRichTips(4,"领取成功")
		for i = 1,3 do
			get_Button[i]:setVisible(false)
		end
		if myFamily:getFamilyId() == myFamilyBattle:getWinFamilyOneId() then
			overButton[1]:setVisible(true)
		elseif myFamily:getFamilyId() == myFamilyBattle:getWinFamilyTwoId() then
			overButton[2]:setVisible(true)
		elseif myFamily:getFamilyId() == myFamilyBattle:getWinFamilyThreeId() then
			overButton[3]:setVisible(true)
		end
	end
	local listener = cc.EventListenerCustom:create("Get_FamilyAward", FamilyBattleGetPayCallBack)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);


    local function parseAwardStr(awardStr)
    	self.isGiftTrue = false
		local awardList = {}
		local itemType,itemCount,startIndex,endIndex
		local str = awardStr
		while(str ~= "")
		do
			local item = {}
			startIndex,endIndex,item.itemType,item.itemCount = string.find(str,"(%d+)|(%d+)")
			table.insert(awardList,item)
			str = string.sub(str,endIndex+2,-1)
		end
		return awardList
	end

    local function onGetFinishAward(EventCustom)
		local awardStr = wd.GlobalData:getInstance():getAchieveAward()
		local awardList = parseAwardStr(awardStr)
		local getData,itemInfo
		for i,v in ipairs(awardList) do
			v.itemType = tonumber(v.itemType)
			v.itemCount = tonumber(v.itemCount)	
			if v.itemType == wd.rewardItemType.MAIL_GEM or v.itemType == wd.rewardItemType.MAIL_MONEY then
				wd.GlobalData:getInstance():addMoneyToRole(v.itemType,v.itemCount)
				local event = cc.EventCustom:new("Update_Main")
				cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
			else
				wd.GlobalData:getInstance():addItem(v.itemType,v.itemCount)
			end
			if v.itemType ~= 1 and v.itemType ~= 2 then
				getData = string.format("1#%d|%d",v.itemType,v.itemCount)
			else
				getData = string.format("4#%d|%d",v.itemType,v.itemCount)
			end
			itemInfo = wd.getItemInfo(getData)
			if itemInfo~= nil and itemInfo.name ~= nil and itemInfo.color ~= nil and itemInfo.count ~= nil then
				local msg = {}
				table.insert(msg,"获得")
				table.insert(msg,string.format("{t=[%s],c=[%d]}",itemInfo.name,itemInfo.color))
				table.insert(msg,string.format("*%d",itemInfo.count))
				wd.showRichTips(wd.tipsType.Get,msg)
			end
		end
		local event = cc.EventCustom:new("Get_FamilyAward")
		cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	end

	local listenerGetAward = cc.EventListenerCustom:create("Family_Battle_Get_Pay", onGetFinishAward)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listenerGetAward, 1)
    
	--------------------------------------------增加逻辑判断-----------------------------------------------

	local canChair = false
    local canViceChair = false
    if myFamily:getMyJob() == wd.familyJobType.Family_Father then      --族长
    	canChair = true
    end

    if myFamily:getMyJob() == wd.familyJobType.Family_Mother then      --副族长
    	canViceChair = true
    end
   
   ----------------------------------------------参战家族查看----------------------------------------------

    local familyOne = {}		--城池1参战家族
    local familyTwo = {}		--城池2参战家族
    local familyThree = {}		--城池3参战家族

    for i=0, wd.GlobalData:getInstance():getFamilyBattleThreeJoinerSize()-1 do
        local aa = wd.GlobalData:getInstance():getFamilyBattleThreeJoiner(i)
    
        local item = {}
        item.id = aa:getJoinFamilyId()
        item.name = aa:getJoinFamilyName()

        familyThree[item.id] = item
    end

    for i=0, wd.GlobalData:getInstance():getFamilyBattleTwoJoinerSize()-1 do
        local aa = wd.GlobalData:getInstance():getFamilyBattleTwoJoiner(i)

        local item = {}
        item.id = aa:getJoinFamilyId()
        item.name = aa:getJoinFamilyName()

        familyTwo[item.id] = item
    end

    for i=0, wd.GlobalData:getInstance():getFamilyBattleOneJoinerSize()-1 do
        local aa = wd.GlobalData:getInstance():getFamilyBattleOneJoiner(i)

        local item = {}
        item.id = aa:getJoinFamilyId()
        item.name = aa:getJoinFamilyName()

        
        familyOne[item.id] = item
    end


    for i = 1 , 3 do
    	local listView = Button_quick[i]:getChildByName("Tips_Box" .. i):getChildByName("ListView_" .. i)
    	if i == 1 then
    		for i, v in pairs(familyOne) do
    			if v ~= nil then
    				--local labelName = ccui.Text:create()
    				--labelName:setString(v.name .. "(已报名)")
    				--listView:pushBackCustomItem(labelName)
    				local richTextLabel = ccui.RichText:create()
    				local richElement1 = ccui.RichElementText:create(1,cc.c3b(255,255,255),255,v.name,"Helvetica",15) 
    				local richElement2 = ccui.RichElementText:create(2,cc.c3b(255,0,0),255,"  已报名","Helvetica",15)
	   				richTextLabel:pushBackElement(richElement1)
	    			richTextLabel:pushBackElement(richElement2)	
		   			richTextLabel:formatText()
		   			local labelSize = richTextLabel:getContentSize()
		   			richTextLabel:ignoreContentAdaptWithSize(false)
		   			listView:pushBackCustomItem(richTextLabel)
    			end
    		end
    	elseif i == 2 then
    		for i, v in pairs(familyTwo) do
    			if v ~= nil then
    				--local labelName = ccui.Text:create()
    				--labelName:setString(v.name .. "(已报名)")
    				--listView:pushBackCustomItem(labelName)
    				local richTextLabel = ccui.RichText:create()
    				local richElement1 = ccui.RichElementText:create(1,cc.c3b(255,255,255),255,v.name,"Helvetica",15) 
    				local richElement2 = ccui.RichElementText:create(2,cc.c3b(255,0,0),255,"  已报名","Helvetica",15)
	   				richTextLabel:pushBackElement(richElement1)
	    			richTextLabel:pushBackElement(richElement2)	
		   			richTextLabel:formatText()
		   			local labelSize = richTextLabel:getContentSize()
		   			richTextLabel:ignoreContentAdaptWithSize(false)
		   			listView:pushBackCustomItem(richTextLabel)
    			end
    		end
    	elseif i == 3 then
    		for i, v in pairs(familyThree) do
    			if v ~= nil then
    				--local labelName = ccui.Text:create()
    				--labelName:setString(v.name .. "(已报名)")
    				--listView:pushBackCustomItem(labelName)
    				local richTextLabel = ccui.RichText:create()
    				local richElement1 = ccui.RichElementText:create(1,cc.c3b(255,255,255),255,v.name,"Helvetica",15) 
    				local richElement2 = ccui.RichElementText:create(2,cc.c3b(255,0,0),255,"  已报名","Helvetica",15)
	   				richTextLabel:pushBackElement(richElement1)
	    			richTextLabel:pushBackElement(richElement2)	
		   			richTextLabel:formatText()
		   			local labelSize = richTextLabel:getContentSize()
		   			richTextLabel:ignoreContentAdaptWithSize(false)
		   			listView:pushBackCustomItem(richTextLabel)
    			end
    		end
    	end
    end

    ---------------------------------------------------绘制界面----------------------------------------------

	local function returnFamilyBattleStatus(time)
		local tab = os.date("*t",time)
		local y = tab.year
		local m = tab.month
		local d = tab.day
		local hour = tab.hour
		local min = tab.min
		local sec = tab.sec
		local iWeek = tonumber(os.date("%w",time))
		if iWeek == 0 then
			iWeek = 7
		end

		local desTime = 0
		local endTime = 0
		--if m == 1 or m == 2 then
		--	m = m + 12
		--	y = y - 1
		--end
		--local iWeek = math.floor((d + 2*m + 3 * (m + 1)/5 + y + y/4 - y/100 + y/400)%7)   --0对应周一  1对应周二  2对应周三 。。。
		--print(y,m,d,hour,min,sec,iWeek)
		--城战对应四个状态
		--家族报名—成员参战报名—城战争夺战进行中—城战归属权
		if iWeek == 1 or iWeek == 4 then  --报名时间每周一0时至24时）
			desTime = (23-hour)*3600+(59-min)*60+(59-sec)
            endTime = desTime + os.time()
			stageText:setString("家族报名中");
			for i = 1,3 do
				if myCity == 0 then
					Button_apply[i]:setVisible(true)
					Button_apply[i]:setPressedActionEnabled(true)
					Button_apply[i]:addTouchEventListener(
					function(sender,eventType)
	            		if eventType == ccui.TouchEventType.ended then
	            			if canChair == true or canViceChair == true then -- 判断是不是族长和副族长
	            				local layerClass = require("src.game.family.Family_War_Tip")
								local layer = layerClass.create()
								layer:createLayerMenu(i)
								self:addChild(layer)
								--self.dataHandler:requestApplyFamilyBattle(i)--传入城市ID
								whichity = i
							else
								wd.showRichTips(4,"不可操作")
							end
	            		end
	       			end
					)
				else
					Button_apply[i]:setVisible(false)
					Image_over[myCity]:setVisible(true)
				end
			end
		elseif (iWeek == 2 and hour>= 0 and hour <= 19) or (iWeek == 5 and hour>= 0 and hour <= 19) then  --成员参战时间（每周二0时至20时）
			desTime = (19-hour)*3600+(59-min)*60+(59-sec)
            endTime = desTime + os.time()
			stageText:setString("成员参战报名中")
			local stats = false
			local allActor = myFamily:getFightCityActor()
			local item = string.split(allActor, ",")
			for i,v in pairs(item) do
				if tonumber(v) == wd.GlobalData:getInstance():getRoleId() then
					stats = true

				end
			end
			if stats == false then   --判断是否已经报名
				for i = 1,3 do
					Button_join[i]:setVisible(true)
					Button_join[i]:setPressedActionEnabled(true)
					Button_join[i]:addTouchEventListener(
					function(sender,eventType)
	            		if eventType == ccui.TouchEventType.ended then
	            			if myCity == i then
								self.dataHandler:requestJoinFamilyBattle()--传入城市ID
							else
								wd.showRichTips(4,"不可操作")	
							end
	            		end
	       			end
					)
				end
			else
				Image_over[myCity]:setVisible(true)
			end
			for i = 1,3 do
				Button_quick[i]:setVisible(true)
				Button_quick[i]:setPressedActionEnabled(true)
				Button_quick[i]:addTouchEventListener(
				function(sender,eventType)
					if eventType == ccui.TouchEventType.ended then
						if i == 1 then
							Button_quick[2]:getChildByName("Tips_Box" .. 2):setVisible(false)
							Button_quick[3]:getChildByName("Tips_Box" .. 3):setVisible(false)
						elseif i == 2 then
							Button_quick[1]:getChildByName("Tips_Box" .. 1):setVisible(false)
							Button_quick[3]:getChildByName("Tips_Box" .. 3):setVisible(false)
						elseif i == 3 then
							Button_quick[2]:getChildByName("Tips_Box" .. 2):setVisible(false)
							Button_quick[1]:getChildByName("Tips_Box" .. 1):setVisible(false)
						end

						if Button_quick[i]:getChildByName("Tips_Box" .. i):isVisible() == false then
							Button_quick[i]:getChildByName("Tips_Box" .. i):setVisible(true)
						else
							Button_quick[i]:getChildByName("Tips_Box" .. i):setVisible(false)
						end
					end
				end
				)
			end
		elseif (iWeek == 2 and hour>= 20 and hour < 21) or (iWeek == 5 and hour>= 20 and hour < 21) then  --城战争夺战进行中(计算)
			desTime = (20-hour)*3600+(59-min)*60+(59-sec)
            endTime = desTime + os.time()
			stageText:setString("城战争夺中")
			for i=1 ,3 do
				effict_Button[i]:setVisible(true)
				Button_quick[i]:setVisible(true)
				Button_quick[i]:setPressedActionEnabled(true)
				local animation = cc.Animation:create()
			    for i = 1, 6 do
			        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("pk_effect_%d.png", i)))
			    end
			    
			    animation:setDelayPerUnit(0.08)
			    animation:setLoops(1)
			    local action = cc.Animate:create(animation)
				local repeatAction = cc.RepeatForever:create(action)
   				effict_Button[i]:runAction(repeatAction)

   				Button_quick[i]:addTouchEventListener(
				function(sender,eventType)
					if eventType == ccui.TouchEventType.ended then
						if Button_quick[i]:getChildByName("Tips_Box" .. i):isVisible() == false then
							Button_quick[i]:getChildByName("Tips_Box" .. i):setVisible(true)
						else
							Button_quick[i]:getChildByName("Tips_Box" .. i):setVisible(false)
						end
					end
				end
				)

			end
		else  --城战归属权
			stageText:setString("城战已结束")
			if myFamilyBattle:getOneName() == "" then
				Text_zhanling[1]:setString("无家族占领")
			else
				Text_zhanling[1]:setString("占领: " .. myFamilyBattle:getOneName())
			end
			if myFamilyBattle:getTwoName() == "" then
				Text_zhanling[2]:setString("无家族占领")
			else
				Text_zhanling[2]:setString("占领: " .. myFamilyBattle:getTwoName())
			end
			if myFamilyBattle:getThreeName() == "" then
				Text_zhanling[3]:setString("无家族占领")
			else
				Text_zhanling[3]:setString("占领: " .. myFamilyBattle:getThreeName())
			end
			
			if iWeek < 4 then
			    desTime = (23-hour)*3600+(59-min)*60+(59-sec)+(3-iWeek)*3600*24
                endTime = desTime + os.time()
            else
                desTime = (23-hour)*3600+(59-min)*60+(59-sec)+(7-iWeek)*3600*24
                endTime = desTime + os.time()
            end
			if myFamily:getFamilyId() == myFamilyBattle:getWinFamilyOneId() then
				if myFamilyGuard:getFightCityGift() == 0 and self.isGiftTrue == true then
					get_Button[1]:setVisible(true)
				else
					overButton[1]:setVisible(true)
				end
			elseif myFamily:getFamilyId() == myFamilyBattle:getWinFamilyTwoId() then
				if myFamilyGuard:getFightCityGift() == 0 and self.isGiftTrue == true then
					get_Button[2]:setVisible(true)
				else
					overButton[2]:setVisible(true)
				end
			elseif myFamily:getFamilyId() == myFamilyBattle:getWinFamilyThreeId() then
				if myFamilyGuard:getFightCityGift() == 0 and self.isGiftTrue == true then
					get_Button[3]:setVisible(true)
				else
					overButton[3]:setVisible(true)
				end
			end
			for i = 1, 3 do
				get_Button[i]:addTouchEventListener(
				function(sender,eventType)
					if eventType == ccui.TouchEventType.ended then
						self.dataHandler:requestGetFamilyBattlePay()
					end
				end
				)
			end
		end

		-------------------------计算时间----------------------------------
		local h1,m1,s1,nowTime
		local function setTime()
            nowTime = endTime - os.time()
            if nowTime > 0 then
                h1 = math.floor(nowTime/3600)
                m1 = math.floor((nowTime - h1 * 3600)/60)
                s1 = nowTime%60
				timeText:setString(string.format("%02d:%02d:%02d",h1,m1,s1))
			else
				if self.timeSchedule ~= nil then
					cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.timeSchedule)
					self.timeSchedule = nil
				end
				self:showSubView(4)
			end
		end
		setTime()

		self.timeSchedule = cc.Director:getInstance():getScheduler():scheduleScriptFunc(setTime, 1, false)

		-----------------------------战况显示---------------------------------
		battleProgress:addTouchEventListener(
	        function(sender,eventType)
	            if eventType == ccui.TouchEventType.ended then
	            	if (iWeek == 1) or (iWeek == 2 and hour>= 0 and hour <= 19) or (iWeek == 2 and hour>= 20 and hour < 21) then
	            		wd.showRichTips(4,"暂不能查看")
	            	else
	            		self.dataHandler:requestGetFamilyBattleDate()
	            		--local layerClass = require("src.game.family.family_War_Progress")
						--local layer = layerClass.create()
						--self:addChild(layer)
	            	end
					
	            end
	        end
	    )
	end

	returnFamilyBattleStatus(myFamilyTime:getServerTime())

	self.contentPanel:addChild(node)

	node:setPosition(0,0)
	
end

return Family_Member_TempleLayer
