
local Family_MessageBox_Layer = class("Family_MessageBox_Layer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function Family_MessageBox_Layer.create(titleSpriteName,msg,callbackFunc)
    local layer = Family_MessageBox_Layer.new()
    layer:createLayerMenu(titleSpriteName,msg,callbackFunc)
    return layer
end

function Family_MessageBox_Layer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.dataHandler = wd.familyHandler 
end

function Family_MessageBox_Layer:clear()
	self:removeFromParent()
	local event = cc.EventCustom:new("Remove_Tips")
	cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	--cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_AchieveList")
end

function Family_MessageBox_Layer:createLayerMenu(titleSpriteName,msg,callbackFunc)
    local node = tolua.cast(cc.CSLoader:createNode("ui/family/Family_Tips_Layer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)
	
	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
	local titleSprite =  tolua.cast(mainPanel:getChildByName("Title_Sprite"), "cc.Sprite")
	titleSprite:setSpriteFrame(titleSpriteName)
	
	local msgPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Msg_Panel"), "ccui.Widget")
	local size = msgPanel:getContentSize()
	if type(msg) == "string" then
		local text = ccui.Text:create()
		text:ignoreContentAdaptWithSize(false)
		text:setTextAreaSize(cc.size(size.width-30,size.height))
		text:setFontSize(25)
		text:setString(msg)
		msgPanel:addChild(text)
		
		text:setPosition(size.width/2,size.height/2)
	elseif type(msg) == "table" then
		local richTextLabel = ccui.RichText:create()
		local startIndex,lastIndex,str,richElement
		for i,v in ipairs(msg) do
			if (string.find(v,"{") ~= nil) then
				startIndex,lastIndex,str = string.find(v,"{n=%[(.-)%]}") 
				richElement = ccui.RichElementText:create(2,cc.c3b(255,0,0),255,str,"Helvetica",25) 
			else
				richElement = ccui.RichElementText:create(2,cc.c3b(255,255,255),255,v,"Helvetica",25) 
			end
			richTextLabel:pushBackElement(richElement)
		end
		richTextLabel:formatText()
		local textSize = richTextLabel:getContentSize()
		if textSize.width > size.width-25 then
			self.upHeight = math.ceil(textSize.width / size.width) * textSize.height
		else
			self.upHeight = 25
		end
		richTextLabel:ignoreContentAdaptWithSize(false)
		richTextLabel:setContentSize(size.width,self.upHeight)
		msgPanel:addChild(richTextLabel)
		richTextLabel:setPosition(size.width/2,size.height/2)
	end
	
    local backBtn = ccui.Helper:seekWidgetByName(node,"Close_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
            end
        end
    )
	
		
	local enterBtn = ccui.Helper:seekWidgetByName(node,"Enter_Button")
	enterBtn:setPressedActionEnabled(true)
    enterBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				callbackFunc()
            end
        end
    )
	
	local cancelBtn = ccui.Helper:seekWidgetByName(node,"Cancel_Button")
	cancelBtn:setPressedActionEnabled(true)
    cancelBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
            end
        end
    )

	
end

return Family_MessageBox_Layer
