
local Family_Upgrade_Layer = class("Family_Upgrade_Layer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function Family_Upgrade_Layer.create(family)
    local layer = Family_Upgrade_Layer.new()
    layer:createLayerMenu(family)
    return layer
end

function Family_Upgrade_Layer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.dataHandler = wd.familyHandler 
end

function Family_Upgrade_Layer:clear()
	self:removeFromParent()
	--cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_AchieveList")
	
end

function Family_Upgrade_Layer:createLayerMenu(family)
    local node = tolua.cast(cc.CSLoader:createNode("ui/family/Family_Upgrade_Layer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)
	
    local backBtn = ccui.Helper:seekWidgetByName(node,"Close_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
            end
        end
    )
	
		
	local enterBtn = ccui.Helper:seekWidgetByName(node,"Enter_Button")
	enterBtn:setPressedActionEnabled(true)
    enterBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				if family:getCurExperience() < family:getFullExperience() then
					wd.showRichTips(4,"升级条件未满足")
				else
					self.dataHandler:requestUpgradeFamily()
				end
            end
        end
    )
	
	local cancelBtn = ccui.Helper:seekWidgetByName(node,"Cancel_Button")
	cancelBtn:setPressedActionEnabled(true)
    cancelBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
            end
        end
    )

	local exprienceLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Prosperity_Label"), "ccui.Text")
	local expStr = string.format("%d/%d",family:getCurExperience() , family:getFullExperience())
	if family:getCurExperience() < family:getFullExperience() then
		expStr = expStr.."(未满足)"
	end
	exprienceLabel:setString(expStr)
	
	local currentLevelLabel =  tolua.cast(ccui.Helper:seekWidgetByName(node,"Current_Level_Label"), "ccui.Text")
	currentLevelLabel:setString(string.format("%d级",family:getLevel()))
	local nextLevelLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Next_Level_Label"), "ccui.Text")
	nextLevelLabel:setString(string.format("%d级",family:getLevel()+1))
	
	local currentCountLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Current_Count"), "ccui.Text")
	currentCountLabel:setString(family:getLimitCount())
	
	local nextCountLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Next_Count"), "ccui.Text")
	nextCountLabel:setString(wd.GlobalData:getInstance():getFamilyLimitCountByLevel(family:getLevel()+1))
end

return Family_Upgrade_Layer
