local Family_War_Tip = class("Family_War_Tip",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function Family_War_Tip.create()
    local layer = Family_War_Tip.new()
    return layer
end

function Family_War_Tip:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.dataHandler = wd.familyHandler 
end

function Family_War_Tip:createLayerMenu(tag)
    local node = tolua.cast(cc.CSLoader:createNode("ui/familyWar/FamilyWarTips.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

    local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
    
    local backBtn = tolua.cast(mainPanel:getChildByName("Close_Button"), "ccui.Button")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )

    local backBtn2 = tolua.cast(mainPanel:getChildByName("Cancel_Button"), "ccui.Button")
    backBtn2:setPressedActionEnabled(true)
    backBtn2:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    
    local challengeBtn = tolua.cast(mainPanel:getChildByName("Enter_Button"), "ccui.Button")
    challengeBtn:setPressedActionEnabled(true)
    challengeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self.dataHandler:requestApplyFamilyBattle(tag)
                self:removeFromParent()
            end
        end
    )

    local function getItemListCallBack(dropStr)
        local awardList = {}
        local id,itemCount,type,startIndex,endIndex
        local str = dropStr
        while(str ~= "")
        do
            local item = {}
            startIndex,endIndex,type,id,itemCount = string.find(str,"(%d)#(%d+)|(%d+)")
            item.id = tonumber(id)
            item.itemCount = tonumber(itemCount)
            item.type = tonumber(type)
            table.insert(awardList,item)
            str = string.sub(str,endIndex+2,-1)
        end
        return awardList
    end

    local familyCityData = wd.GlobalData:getInstance():getFamilyCityDataInXml(tag-1)
    local str = getItemListCallBack(familyCityData:getGongzi())
    local labelStr = ""
    for i,v in ipairs(str) do
        if v.type == 1 then
            local item = wd.GlobalData:getInstance():getToolsItemInXml(v.id)
            local name = item:getName()
            labelStr = labelStr .. name .. " X " .. v.itemCount .." "
        elseif v.type == 4 then
            if v.id == 1 then
                labelStr = labelStr .. "元宝" .. " X " .. v.itemCount .. " "
            end
        end
    end
    
    mainPanel:getChildByName("Text_2_0"):setString(labelStr)
end


return Family_War_Tip