
local FirstChargeLayer = class("FirstChargeLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function FirstChargeLayer.create()
    local layer = FirstChargeLayer.new()
    layer:createLayerMenu("2#100|1,1#1020|100,1#1021|100")
    return layer
end

function FirstChargeLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
    
    self.getList = nil
end
function FirstChargeLayer:registerEventListener()

    local function getCallback(EventCustom)
        local getData = wd.GlobalData:getInstance():getMessage("Get_Item")
        if getData:len() >= 5 then

            local layerClass = require("src.game.package.ToolsGetLayer")
            local layer = layerClass.create()
            layer:createLayerMenu(getData)
            self:getParent():addChild(layer)

            self:unregisterEventListener()
            self:removeFromParent()
        end
    end

    local listener = cc.EventListenerCustom:create("Get_Item", getCallback)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end

function FirstChargeLayer:unregisterEventListener()
    cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_Item")
end

-- function FirstChargeLayer:parse(getData)

--     local startIndex
--     local lastIndex
--     local type, id, count

--     local i = 0

--     if self.getList ~= nil then

--         while(getData:len()>=5) do
--             startIndex,lastIndex,type,id,count  = string.find(getData,"(%d+)#(%d+)|(%d+)")

--             if type == nil or id == nil or count == nil then
--                 break
--             end

--             type = tonumber(type)
--             id = tonumber(id)
--             count = tonumber(count)

--             if type == wd.ItemType.Tools then
--                 self:tools(id, count)
--             elseif type == wd.ItemType.Equip then
--                 self:equip(id, count)
--             elseif type == wd.ItemType.EquipList then
--                 self:equipList(id, count)
--             elseif type == wd.ItemType.Special then
--                 self:special(id, count)
-- 			elseif type == wd.ItemType.Soul then
-- 				self:soul(id,count)
--             end

--             getData = string.sub(getData,lastIndex+1,-1)
--             i = i + 1
--         end
--     end

--     if i >= 3 then
--         self.getList:setStartMargin(10)
--     else
--         self.getList:setStartMargin((320-i*86)/2)
--     end
-- end

function FirstChargeLayer:tools(toolsId, count)

    local item = wd.GlobalData:getInstance():getToolsItemInXml(toolsId)

    if item == nil then
        return
    end

    local btn = ccui.Button:create("item_button.png", "item_button.png", "", ccui.TextureResType.plistType)
    btn:setAnchorPoint(cc.p(0,0))
    btn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass =  require("src.game.package.ToolsTipsLayer")
                local layer = layerClass.create()
                layer:createLayerMenu(toolsId, true)
                self:addChild(layer)
            end
        end
    )

    local itemNode = tolua.cast(cc.CSLoader:createNode("ui/package/ItemNode.csb"),"ccui.Widget")
    btn:addChild(itemNode)

    local image = tolua.cast(itemNode:getChildByName("Item_Sprite"), "cc.Sprite")
    image:setSpriteFrame(string.format("%d.png",item:getToolsId()))
	if item:getQuality() == 5 then
		wd.itemEffect(image)
	end
    local color = tolua.cast(itemNode:getChildByName("Color_Sprite"), "cc.Sprite")
    color:setSpriteFrame(string.format("%02d.png",item:getQuality()))

    local nameLabel = tolua.cast(itemNode:getChildByName("Name_Label"), "ccui.Text")
    nameLabel:setString(item:getName())

    local quantityLabel = tolua.cast(itemNode:getChildByName("Number_Label"), "ccui.Text")
    quantityLabel:setString(string.format("%d", count))

    self.getList:pushBackCustomItem(btn)
end

function FirstChargeLayer:equip(equipId, count)
    local item = wd.GlobalData:getInstance():getEquipItemInXml(equipId)

    if item == nil then
        return
    end

    local btn = ccui.Button:create("item_button.png", "item_button.png", "", ccui.TextureResType.plistType)
    btn:setAnchorPoint(cc.p(0,0))
    btn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.shop.ArtifactTipsLayer")
                local layer = layerClass.create()
                layer:createLayerMenu(item)
                self:addChild(layer)
            end
        end
    )

    local itemNode = tolua.cast(cc.CSLoader:createNode("ui/package/ItemNode.csb"),"ccui.Widget")
    btn:addChild(itemNode)
    
    local image = tolua.cast(itemNode:getChildByName("Item_Sprite"), "cc.Sprite")
    image:setSpriteFrame(string.format("%d.png",item:getEquipId()))
    
    wd.equipEffect(item, image)

    local color = tolua.cast(itemNode:getChildByName("Color_Sprite"), "cc.Sprite")
    color:setSpriteFrame(string.format("%02d.png",5))

    local nameLabel = tolua.cast(itemNode:getChildByName("Name_Label"), "ccui.Text")
    nameLabel:setString(item:getName())

    local quantityLabel = tolua.cast(itemNode:getChildByName("Number_Label"), "ccui.Text")
    quantityLabel:setString(string.format("%d", count))

    self.getList:pushBackCustomItem(btn)

end


function FirstChargeLayer:equipList(equipList, count)

end

function FirstChargeLayer:special(specialId, count)

    if specialId == wd.ItemId.Gem or specialId == wd.ItemId.Gold or specialId == wd.ItemId.ArtifactPoints  then

        local btn = ccui.Button:create("item_button.png", "item_button.png", "", ccui.TextureResType.plistType)
        btn:setAnchorPoint(cc.p(0,0))

        local itemNode = tolua.cast(cc.CSLoader:createNode("ui/package/ItemNode.csb"),"ccui.Widget")
        btn:addChild(itemNode)

        local image = tolua.cast(itemNode:getChildByName("Item_Sprite"), "cc.Sprite")
        local color = tolua.cast(itemNode:getChildByName("Color_Sprite"), "cc.Sprite")
        local nameLabel = tolua.cast(itemNode:getChildByName("Name_Label"), "ccui.Text")
        local quantityLabel = tolua.cast(itemNode:getChildByName("Number_Label"), "ccui.Text")

        if specialId == wd.ItemId.Gem then

            color:setSpriteFrame(string.format("%02d.png",5))

            nameLabel:setString("元宝")


        elseif specialId == wd.ItemId.Gold then

            color:setSpriteFrame(string.format("%02d.png",4))

            nameLabel:setString("金币")

        elseif specialId == wd.ItemId.ArtifactPoints then

            color:setSpriteFrame(string.format("%02d.png",3))

            nameLabel:setString("神器积分")

        end

        image:setSpriteFrame(string.format("%d.png",specialId))

        quantityLabel:setString(string.format("%d", count))

        self.getList:pushBackCustomItem(btn)
    end

end

function FirstChargeLayer:soul(soulId, count)
    local soulItem = wd.soulHandler:getSoulInXmlForId(soulId)

    if soulItem == nil then
        return
    end

    local btn = ccui.Button:create("item_button.png", "item_button.png", "", ccui.TextureResType.plistType)
    btn:setAnchorPoint(cc.p(0,0))
    btn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.soul.SoulTipsLayer")
				local layer = layerClass.create()
				layer:createLayerMenu(soulItem,0)
				self:addChild(layer)
            end
        end
    )

    local soulNode = tolua.cast(cc.CSLoader:createNode("ui/package/soul/SoulNode.csb"),"ccui.Widget")
    btn:addChild(soulNode)
    
	local soulBtn = tolua.cast(soulNode:getChildByName("Soul_Button"), "ccui.Button")
    soulBtn:setPressedActionEnabled(true)
	soulBtn:setSwallowTouches(false)
    local image = tolua.cast(soulNode:getChildByName("Soul_Sprite"), "cc.Sprite")
	image:setSpriteFrame(string.format("%d.png",soulItem.id))
	wd.soulEffect(soulItem.quality,image)
	
	local color = soulItem.grade
	local colorSprite = tolua.cast(soulNode:getChildByName("Color_Sprite"), "cc.Sprite")
	colorSprite:setSpriteFrame(string.format("%02d.png",color))

	local gradeLabel = tolua.cast(soulNode:getChildByName("Grade_Label"), "ccui.Text")
	gradeLabel:setString(soulItem.grade)
	
	local nameLabel = tolua.cast(soulNode:getChildByName("Name_Label"), "ccui.Text")
	nameLabel:setColor(wd.colorType(color))
	
	if soulItem.soulGrade >0 then
		nameLabel:setString(string.format("%s+%d",soulItem.name, soulItem.soulGrade))
	else
		nameLabel:setString(soulItem.name)
	end
	local levelLabel = tolua.cast(soulNode:getChildByName("Level_Label"), "ccui.TextBMFont")
	local levelBox = tolua.cast(soulNode:getChildByName("Level_Box"), "cc.Sprite")
	levelLabel:setVisible(false)
	levelBox:setVisible(false)

    self.getList:pushBackCustomItem(btn)

end

function FirstChargeLayer:createLayerMenu(getData)
    local node = tolua.cast(cc.CSLoader:createNode("ui/firstcharge/FirstChargeLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Back_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:unregisterEventListener()
                self:removeFromParent()
            end
        end
    )
    
    
    local role = wd.GlobalData:getInstance():getRoleData()
    
    local chargeBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Charge_Button"), "ccui.Widget")
    chargeBtn:setPressedActionEnabled(true)
    chargeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:unregisterEventListener()
                local layerClass = require("src.game.charge.ChargeLayer")
                local layer = layerClass.create()
                self:getParent():addChild(layer)
                self:removeFromParent()
            end
        end
    )
    if role:getChargeDouble() == true then 
        chargeBtn:setVisible(true)
    else
        chargeBtn:setVisible(false)
    end
    
    local getBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Get_Button"), "ccui.Widget")
    getBtn:setPressedActionEnabled(true)
    getBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                wd.TranscodingSend:getFirstCharge()
            end
        end
    )
    
    if role:getChargeFirst() == true then 
        getBtn:setVisible(true)
    else
        getBtn:setVisible(false)
    end

    
    local getList = tolua.cast(ccui.Helper:seekWidgetByName(node,"Contents_ListView"), "ccui.ListView")
    self.getList = getList
    
    require("src.game.package.SetupTools"):create(getList,getData)
    -- self:parse(getData)
    self:registerEventListener()
end


return FirstChargeLayer