local MapBossTips = class("MapBossTips",function()
    return cc.Layer:create()
end)

function MapBossTips:create(fn)
    local layer = MapBossTips.new()
    layer:setup(fn)
    return layer
end

function MapBossTips:setup(fn)
    local node = tolua.cast(cc.CSLoader:createNode("ui/map/MapBossTips.csb"), "ccui.Widget")
    self:addChild(node)
    
    local item = wd.GlobalData:getInstance():getToolsItemForId(1031)
    local quantity
    if not item then 
        quantity = 0
    else
        quantity = item:getQuantity()
    end
    
    local challengeNum = tolua.cast(ccui.Helper:seekWidgetByName(node,"challenge_num"), "ccui.Text")
    challengeNum:setString(quantity)
    if quantity == 0 then
        challengeNum:setColor(cc.c3b(255,0,0))
    end
    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Back_Button"), "ccui.Button")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    local cancelBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Cancel_Button"), "ccui.Button")
    cancelBtn:setPressedActionEnabled(true)
    cancelBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    local sureBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Sure_Button"), "ccui.Button")
    sureBtn:setPressedActionEnabled(true)
    sureBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if fn and quantity > 0 then
                    fn()
                elseif quantity < 1 then
                    wd.showRichTips(4,"挑战令不足")
                end
            end
        end
    )
end

return MapBossTips