local ExchangeArtifactLayer = class("ExchangeArtifactLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function ExchangeArtifactLayer.create()
    local layer = ExchangeArtifactLayer.new()
    return layer
end

function ExchangeArtifactLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
	self.dataHandler = wd.shopHandler
end

function ExchangeArtifactLayer:createLayerMenu(artifact)
    local priceType = artifact:getPriceType()
    local node = tolua.cast(cc.CSLoader:createNode("ui/shop/ExchangeArtifactLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)
	
	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
	local needText = tolua.cast(mainPanel:getChildByName("need_text"), "ccui.Text")
    
    local hadPoints
    if priceType == 8 then
        hadPoints = wd.GlobalData:getInstance():getRoleArtifactPoints()
        needText:setString("需要神点")
	else
        hadPoints = wd.GlobalData:getInstance():getRoleGem()
        needText:setString("需要元宝")
    end
    
    local backBtn = tolua.cast(mainPanel:getChildByName("Close_Button"), "ccui.Button")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
	
	local enterBtn = tolua.cast(mainPanel:getChildByName("Enter_Button"), "ccui.Button")
    enterBtn:setPressedActionEnabled(true)
    enterBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				if tonumber(artifact:getPrice()) > tonumber(hadPoints) then
                    if priceType == 8 then
                        wd.showRichTips(4,"神点不足")
                    else
                        -- wd.showRichTips(4,"元宝不足")
                        local layerClass = require("src.game.charge.ChargeTipsScene")
                        local layer = layerClass:create()
                        self:getParent():addChild(layer)
                        self:removeFromParent()
                        return
                    end
				else
					self.dataHandler:requestExchangeArtifact(artifact:getIndex())
				end
				self:removeFromParent()
            end
        end
    )
	local cancelBtn = tolua.cast(mainPanel:getChildByName("Cancel_Button"), "ccui.Button")
    cancelBtn:setPressedActionEnabled(true)
    cancelBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
	
    --local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
	if artifact then
		local nameLabel = tolua.cast(mainPanel:getChildByName("Name_Label"), "ccui.Text")
        local item = wd.GlobalData:getInstance():getEquipItemInXml(artifact:getArtifactId())
		nameLabel:setString(item:getName())
		
		local priceLabel = tolua.cast(mainPanel:getChildByName("Number_Label"), "ccui.Text")
		priceLabel:setString(artifact:getPrice())
		if tonumber(artifact:getPrice()) > tonumber(hadPoints) then
			priceLabel:setColor(cc.c3b(255,0,0))
		else
			priceLabel:setColor(cc.c3b(255,255,0))
		end
	end
    
    
end


return ExchangeArtifactLayer