local ItemDetailLayer = class("ItemDetailLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function ItemDetailLayer.create()
    local layer = ItemDetailLayer.new()
    return layer
end

function ItemDetailLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
end

function ItemDetailLayer:createLayerMenu(item)
    local node = tolua.cast(cc.CSLoader:createNode("ui/shop/ItemDetailLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)
   
    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Close_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
	
    local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
	if item then
		--local item = wd.GlobalData:getInstance():getToolsItemInXml(itemId)
		local image = tolua.cast(mainPanel:getChildByName("Icon_Sprite"), "cc.Sprite")
		image:setSpriteFrame(string.format("%d.png",item:getMallItemId()))
		if item:getQuality() == 5 then
			wd.itemEffect(image)
		end
		local color = tolua.cast(mainPanel:getChildByName("Color_Sprite"), "cc.Sprite")
		color:setSpriteFrame(string.format("%02d.png",item:getQuality()))
		
		local nameLabel = tolua.cast(mainPanel:getChildByName("Name_Label"), "ccui.Text")
		nameLabel:setString(item:getName())
		
		local decsLabel = tolua.cast(mainPanel:getChildByName("Description_Label"), "ccui.Text")
		decsLabel:setContentSize(cc.size(288, 100))
		decsLabel:setString(item:getDescription())
	end
    
    
end


return ItemDetailLayer