
local SoulDataHandler = class("SoulDataHandler")

local cclog = function(...)
    print(string.format(...))
end


function SoulDataHandler:ctor()
	self:initData()
	self:registerEventListener()
end

function SoulDataHandler:getInstance()
	if not self.instance then
		self.instance = SoulDataHandler.new()
	end
	return self.instance
end

function SoulDataHandler:destroyInstance()
    if self.instance then
        --cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_FinishAwardState")
		self.instance = nil
    end
end

function SoulDataHandler:initData()
	--[[self.randPropertyName = {
		[1] = "Accuracy",
		[2] = "Dodge",
		[3] = "CritAttk",
		[4] = "Drainlife",
		[5] = "Vertigo",
		[6] = "Reincarnate",
		[7] = "Manaprevent",
		[8] = "ExpExpand",
	}
	self.basicPropertyName = {
		[1] = "HP",
		[2] = "MP",
		[3] = "PAttack",
		[4] = "MAttack",
		[5] = "TAttack",
		[6] = "PDefence",
		[7] = "MDefence",
		[8] = "TDefence",
	}--]]
	self.randPropertyName = {
		[1] = "准确",
		[2] = "闪避",
		[3] = "暴击伤害",
		[4] = "吸血",
		[5] = "麻痹",
		[6] = "复活",
		[7] = "护体",
		[8] = "经验加成",
	}
	self.randIsPercent = {
		[1] = false,
		[2] = false,
		[3] = true,
		[4] = true,
		[5] = true,
		[6] = true,
		[7] = true,
		[8] = true,
	
	}
	self.basicPropertyName = {
		[1] = "生命",
		[2] = "法力",
		[3] = "物攻",
		[4] = "魔攻",
		[5] = "道攻",
		[6] = "物防",
		[7] = "魔防",
		[8] = "道防",
	}
	self.basicIsPercent = {
		[1] = true,
		[2] = true,
		[3] = true,
		[4] = true,
		[5] = true,
		[6] = true,
		[7] = true,
		[8] = true,
	
	}
	self.soulXmlList = {}
	self.showSoulList = {}
	local soulXmlSize = wd.GlobalData:getInstance():getSoulXmlSize()
	for i = 0,soulXmlSize-1 do
		local xml = wd.GlobalData:getInstance():getSoulXml(i)
		local soulXml = {}
		soulXml.id = xml:getSoulId()
		soulXml.name = xml:getName()
		soulXml.quality = xml:getQuality()
		soulXml.grade = xml:getGrade()
		soulXml.soulGrade = xml:getSoulGrade()
		soulXml.levelLimit = xml:getLevelLimit()
		soulXml.level = xml:getLevel()
		soulXml.propertyPercent = xml:getPropertyPercent()
		soulXml.randNum = xml:getRandNum()
		soulXml.basicNum = xml:getBasicNum()
		soulXml.exp = xml:getExp()
		soulXml.weard = xml:getWeard()
		local randProList = {}
		local basicProList = {}
		--[[for i = 0,7 do
			local randPro = {}
			randPro.key = self.randPropertyName[i+1]
			randPro.value = xml:getRandPropertyByTag(i)
			randPro.isPercent = self.randIsPercent[i+1]
			table.insert(randProList,randPro)
			local basicPro = {}
			basicPro.key = self.basicPropertyName[i+1]
			basicPro.value = xml:getBasicPropertyByTag(i)
			basicPro.isPercent = self.basicIsPercent[i+1]
			table.insert(basicProList,basicPro)
		end--]]
		soulXml.randProList = randProList
		soulXml.basicProList = basicProList
		table.insert(self.soulXmlList,soulXml)
        table.insert(self.showSoulList,soulXml)
	end
end

function SoulDataHandler:setSoulItem(item)
	local soulItem = {}
	soulItem.id = item:getSoulId()
	soulItem.serverId = item:getServerId()
	soulItem.name = item:getName()
	soulItem.quality = item:getQuality()
	soulItem.grade = item:getGrade()
	soulItem.soulGrade = item:getSoulGrade()
	soulItem.level = item:getLevel()
	soulItem.exp = item:getExp()
	soulItem.levelLimit = item:getLevelLimit()
	soulItem.propertyPercent = item:getPropertyPercent()
	soulItem.randNum = item:getRandNum()
	soulItem.basicNum = item:getBasicNum()
	soulItem.weard = item:getWeard()
	local randProList = {}
	local basicProList = {}
	for i = 0,7 do
		local randPro = {}
		local randKey = item:getRandPropertyByTag(i)
		if randKey ~= -1 then
			randPro.key = self.randPropertyName[randKey]
			randPro.value = item:getRandPropertyValueByTag(randKey-1)
			randPro.isPercent = self.randIsPercent[randKey]
		else
			randPro.key = self.randPropertyName[i+1]
			randPro.value = -1
			randPro.isPercent = self.randIsPercent[i+1]
		end
		table.insert(randProList,randPro)
		local basicPro = {}
		local basicKey = item:getBasicPropertyByTag(i)
		if basicKey ~= -1 then
			basicPro.key = self.basicPropertyName[basicKey]
			basicPro.value = item:getBasicPropertyValueByTag(basicKey-1)
			basicPro.isPercent = self.basicIsPercent[basicKey]
		else
			basicPro.key = self.basicPropertyName[i+1]
			basicPro.value = -1
			basicPro.isPercent = self.basicIsPercent[i+1]
		end
		table.insert(basicProList,basicPro)
	end
	soulItem.randProList = randProList
	soulItem.basicProList = basicProList
	return soulItem
end

function SoulDataHandler:requestSoulCompound(itemId)
	wd.TranscodingSend:soulCompound(itemId)
end

function SoulDataHandler:requestExpandSoulPackage()
	wd.TranscodingSend:expandSoulPackage()
end

function SoulDataHandler:requestSoulWear(serverId,region)
	wd.TranscodingSend:soulWear(serverId,region)
end

function SoulDataHandler:requestSoulUnWear(serverId)
	wd.TranscodingSend:soulUnWear(serverId)
end

function SoulDataHandler:requestSoulUpgrade(serverId)
	wd.TranscodingSend:soulUpgrade(serverId)
end

function SoulDataHandler:requestSoulLevelUp(serverId,state)
	wd.TranscodingSend:getSoulUpExp(serverId,state)
end

function SoulDataHandler:requestSoulRebuild(serverId)
	wd.TranscodingSend:soulRestartProperty(serverId)
end

function SoulDataHandler:requestSoulResolve(serverId)
	wd.TranscodingSend:soulResolve(serverId)
end

function SoulDataHandler:requestSoulAllResolve(grade)
	wd.TranscodingSend:soulAllResolve(grade)
end

function SoulDataHandler:requestBuySoul(buyType)
	wd.TranscodingSend:buySoul(buyType)
end

function SoulDataHandler:getSoulShowList()
	return self.showSoulList
end

function SoulDataHandler:getSoulInXmlForId(soulId)
	for i,v in ipairs(self.soulXmlList) do
		if v.id==soulId then
			return v
		end
	end
end

function SoulDataHandler:registerEventListener()
	
	-- 从服务器接收技能列表回调
	--[[local function onOpenDiscountShop(EventCustom)
		self.discountItemList = {}
		local showDiscountCount = wd.GlobalData:getInstance():getDiscountShowListCount()
		for i = 0,showDiscountCount-1 do
			local discountItemInfo = {}
			local discountItem = wd.GlobalData:getInstance():getDiscountShowItem(i)
			discountItemInfo.id = discountItem:getDiscountId()
			discountItemInfo.title = discountItem:getName()
			discountItemInfo.number = discountItem:getLimitNumber() - discountItem:getHadBuyNum()
			discountItemInfo.price = discountItem:getPrice()
			discountItemInfo.discountPrice = discountItem:getDiscountPrice() 
			discountItemInfo.item = wd.GlobalData:getInstance():getToolsItemInXml(discountItem:getItemId())
			table.insert(self.discountItemList,discountItemInfo)
		end
		local event = cc.EventCustom:new("Update_DiscountList")
		cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	end
	
	local listenerGetState = cc.EventListenerCustom:create("Get_FinishAwardState", getStateCallBack)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listenerGetState, 1)--]]
end

return SoulDataHandler
