
local SoulDegreeRaising = class("SoulDegreeRaising",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function SoulDegreeRaising.create()
    local layer = SoulDegreeRaising.new()
    return layer
end

function SoulDegreeRaising:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
end

function SoulDegreeRaising:createLayerMenu(soulItem)
    local node = tolua.cast(cc.CSLoader:createNode("ui/package/soul/SoulDegreeRaising.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)
	
	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
	
    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Close_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				if self.sequenceAction then
					self.sequenceAction:release()
					self.sequenceAction = nil
				end
                self:removeFromParent()
				cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Soul_Raising")
            end
        end
    )
    local soulData = require("res.config.dict_soul")
	-- before
	local beforeBox = tolua.cast(mainPanel:getChildByName("Before_Box"),"ccui.Widget")
	local soulNode = tolua.cast(beforeBox:getChildByName("Soul_Node"),"ccui.Widget")
	local image = tolua.cast(soulNode:getChildByName("Soul_Sprite"), "cc.Sprite")
	image:setSpriteFrame(string.format("%d.png",soulItem.id))
	wd.soulEffect(soulItem.quality,image)
	local color = soulItem.grade
	local colorSprite = tolua.cast(soulNode:getChildByName("Color_Sprite"), "cc.Sprite")
	colorSprite:setSpriteFrame(string.format("%02d.png",color))
    
	local gradeLabel = tolua.cast(soulNode:getChildByName("Grade_Label"), "ccui.Text")
	gradeLabel:setString(soulItem.grade)

	local levelLabel = tolua.cast(soulNode:getChildByName("Level_Label"), "ccui.TextBMFont")
	levelLabel:setString(string.format("Lv%d",soulItem.level))

	local nameLabel = tolua.cast(beforeBox:getChildByName("Name_Label"),"ccui.Text")
	nameLabel:setString(soulItem.name)
	nameLabel:setColor(wd.colorType(color))
	
	local beforeLevelLabel = tolua.cast(beforeBox:getChildByName("Level_Label"),"ccui.Text")
	beforeLevelLabel:setString(soulData[soulItem.id].level_limit)
	
    
	
    -- need
    local needSoulNode = tolua.cast(mainPanel:getChildByName("Panel_Under"):getChildByName("Soul_Node_Need"),"ccui.Widget")
    local needImage = tolua.cast(needSoulNode:getChildByName("Soul_Sprite"), "cc.Sprite")
    needImage:setSpriteFrame(string.format("%d.png",soulItem.id))
    wd.soulEffect(soulItem.quality,needImage)
    tolua.cast(needSoulNode:getChildByName("Color_Sprite"), "cc.Sprite"):setSpriteFrame(string.format("%02d.png",color))
    tolua.cast(needSoulNode:getChildByName("Grade_Label"), "ccui.Text"):setString(soulItem.grade)
    tolua.cast(needSoulNode:getChildByName("Level_Box"), "cc.Sprite"):setVisible(false)
    tolua.cast(needSoulNode:getChildByName("Level_Label"), "ccui.TextBMFont"):setVisible(false)
    -- tolua.cast(needSoulNode:getChildByName("Level_Label"), "ccui.TextBMFont"):setString(string.format("Lv%d",soulItem.level))
    -- local nameLabel = tolua.cast(needSoulNode:getChildByName("Name_Label"),"ccui.Text")
	-- nameLabel:setString(soulItem.name)
	-- nameLabel:setColor(wd.colorType(color))
    local needText = tolua.cast(mainPanel:getChildByName("Panel_Under"):getChildByName("soul_need"),"ccui.Text")
    local moneyText = tolua.cast(mainPanel:getChildByName("Panel_Under"):getChildByName("Money_Label"),"ccui.Text")
    local cost = soulData[soulItem.id].cost
    needText:setString("需要"..cost.."个")
    moneyText:setString(soulData[soulItem.id].money)
    
    
	-- after
    
    local nextId = soulData[soulItem.id].next_id
    local nextSoulData = soulData[nextId]
	local afterBox = tolua.cast(mainPanel:getChildByName("After_Box"),"ccui.Widget")
	local soulNode = tolua.cast(afterBox:getChildByName("Soul_Node"),"ccui.Widget")
	local image = tolua.cast(soulNode:getChildByName("Soul_Sprite"), "cc.Sprite")
	image:setSpriteFrame(string.format("%d.png",nextId))
	wd.soulEffect(nextSoulData.quality,image)
	local color = nextSoulData.grade
	local colorSprite = tolua.cast(soulNode:getChildByName("Color_Sprite"), "cc.Sprite")
	colorSprite:setSpriteFrame(string.format("%02d.png",color))

	local gradeLabel = tolua.cast(soulNode:getChildByName("Grade_Label"), "ccui.Text")
	gradeLabel:setString(nextSoulData.grade)

	local levelLabel = tolua.cast(soulNode:getChildByName("Level_Label"), "ccui.TextBMFont")
	levelLabel:setString(string.format("Lv%d",soulItem.level))
	local nameLabel = tolua.cast(afterBox:getChildByName("Name_Label"),"ccui.Text")
	nameLabel:setString(nextSoulData.name)
	nameLabel:setColor(wd.colorType(color))
	local afterLevelLabel = tolua.cast(afterBox:getChildByName("Level_Label"),"ccui.Text")
	afterLevelLabel:setString(nextSoulData.level_limit)
	
	local upgradeEffect =  tolua.cast(mainPanel:getChildByName("Upgrade_Effect"),"cc.Sprite")
	local function playAnimation()
		if self.sequenceAction and (not self.sequenceAction:isDone()) then
			return
		end
		if not upgradeEffect then
			return
		end
		upgradeEffect:setVisible(true)
		local animation = cc.Animation:create()
		for i = 1, 5 do
			animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("soulUpgrade_%02d.png", i)))
		end

		animation:setDelayPerUnit(0.15)
		animation:setLoops(1)
		local action = cc.Animate:create(animation)
		
		local function delayCallBackFunc(sender)
			upgradeEffect:setVisible(false)
		end

		local delayCallBack = cc.CallFunc:create(delayCallBackFunc)
		self.sequenceAction = cc.Sequence:create(action, delayCallBack)
		self.sequenceAction:retain()
		upgradeEffect:runAction(self.sequenceAction)
	end
	
    local insertCount = 0
    local array = {}
    local count = wd.GlobalData:getInstance():getSoulItemCount()
    for i=0,count - 1 do
        local item = wd.GlobalData:getInstance():getSoulItem(i)
        if item:getServerId() ~= soulItem.serverId and item:getSoulId() == soulItem.id then
            if item:getLevel() == 0 and item:getSoulGrade() == 0 then
                table.insert(array,item:getServerId())
                insertCount = insertCount + 1
            end
        end
        if insertCount == cost then
            break
        end
    end
    
	local raisingButton = tolua.cast(mainPanel:getChildByName("Panel_Under"):getChildByName("Raising_Button"),"ccui.Button")
	raisingButton:setPressedActionEnabled(true)
    raisingButton:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if #array == cost then
                    local packge = NetPackage:create()
                    packge:add("role_id",wd.GlobalData:getInstance():getRoleData():getRoleId())
                    packge:add("sn",soulItem.serverId)
                    packge:addArray("soul_sn_list",array)
                    packge = packge:encode()
                    wd.TranscodingSend:luaSend(packge,ePCMergeEquipmentSoul)
                else
                    local msg = {}
                    table.insert(msg,"还需要")
                    table.insert(msg,string.format("{u=[%s],c1=[%d],c2=[%d],c3=[%d],c4=[%d]}",cost - #array,0,255,0,255))
                    table.insert(msg,"个")
                    table.insert(msg,string.format("{t=[%s],c=[%d]}",soulItem.name,soulItem.grade))
                    wd.showRichTips(wd.tipsType.System,msg)
                end
            end
        end
    )
	
	local function updataSoul()
        local msg = {}
        table.insert(msg,"合成成功，")
        table.insert(msg,"获得天魂")
        table.insert(msg,string.format("{t=[%s],c=[%d]}",nextSoulData.name,nextSoulData.grade))
        wd.showRichTips(wd.tipsType.System,msg)
		self:removeFromParent()
        cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Soul_Raising")
	end
    
    local listener = cc.EventListenerCustom:create("Soul_Raising", updataSoul)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end


return SoulDegreeRaising