local RegisterLayer = class("RegisterLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function RegisterLayer.create()
    local layer = RegisterLayer.new()
    layer:createLayerMenu()
    return layer
end

function RegisterLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil

    self.username = ""
    self.password = ""
end


function RegisterLayer:registerEventListener()

    local function successCallback(EventCustom)
        self:setAccountPassword()
    end

    local function failedCallback(EventCustom)
        cclog("!!ERROR account register failed !!")
    end

    local listenerSuccess = cc.EventListenerCustom:create("Register_Success", successCallback)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listenerSuccess, 1);
    local listenerFailed = cc.EventListenerCustom:create("Register_Failed", failedCallback)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listenerFailed, 1);

end

function RegisterLayer:unregisterEventListener()
    cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Register_Success")
    cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Register_Failed")
end

function RegisterLayer:setAccountPassword()
    if self.username:len() >= 4 and self.password:len() >= 6 then
        self:getParent():setAccountPassword( self.username, self.password)
        self:unregisterEventListener()
        self:removeFromParent()
    end
end


function RegisterLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/login/RegisterLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Back_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:unregisterEventListener()
                self:removeFromParent()
            end
        end
    )

    local accountField = tolua.cast(ccui.Helper:seekWidgetByName(node,"Account_TextField"), "ccui.TextField")
    accountField:getString()

    local passwordField = tolua.cast(ccui.Helper:seekWidgetByName(node,"Password_TextField"), "ccui.TextField")
    passwordField:getString()
    
    local makesureField = tolua.cast(ccui.Helper:seekWidgetByName(node,"Makesure_TextField"), "ccui.TextField")
    makesureField:getString()

    local registerBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Register_Button"), "ccui.Widget")
    registerBtn:setPressedActionEnabled(true)
    registerBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self.username = accountField:getString()
                self.password = passwordField:getString()
                
				if string.find(self.username,"\"") ~= nil then
					wd.showRichTips(4,"名称不能包含引号")
                    return
                end
				if string.find(self.username,"\'") ~= nil then
					wd.showRichTips(4,"名称不能包含引号")
                    return
                end
                if self.username:len() < 4 then
                    wd.showRichTips(4,"账号长度必须大于4位")
                    return
                end

                if self.password:len() < 6 then
                    wd.showRichTips(4,"密码长度必须大于6位")
                    return
                end
                
                if self.password == makesureField:getString() then
                    wd.TranscodingSend:registerAccount(self.username, self.password)
                else
                    --cclog("!!ERROR makesure error (%s) (%s)!!", self.password, makesureField:getString())
                    wd.showRichTips(4,"密码不一致")
                end
            end
        end
    )

    self:registerEventListener()


end

return RegisterLayer