
local SystemTipsLayer = class("SystemTipsLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function SystemTipsLayer:create()
    self.instance = SystemTipsLayer.new()
end

function SystemTipsLayer:getInstance()
	if not self.instance then
		self:create()
	end
    return self.instance
end

function SystemTipsLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	--self.contentSize = cc.size(self.visibleSize.width,self.visibleSize.height/2)
    self.contentSize = cc.size(1152, 768)
	self.frontTag = 1
	self.fontSize = 20
	self.upHeight = self.fontSize
	self:setContentSize(self.contentSize)	
	--self:setPosition(cc.p(0,0))
end

function SystemTipsLayer:adjustLayout()
	local child
	for i= self.frontTag-1,1,-1 do
		if self:getChildByTag(i) then
			child = self:getChildByTag(i)
			--child:setPosition(cc.p(self.contentSize.width/2,self.upHeight*(self.frontTag-i)))
            local action = cc.MoveBy:create(0.2, cc.p(0, self.fontSize))
            child:runAction(action)
		end
	end
end

function SystemTipsLayer:showTips(msg,color,fontSize)
	if not color then
		color = cc.c3b(255,255,255)
	end
	--[[if fontSize then
		self.fontSize = fontSize
	end--]]
	
    local position = cc.p(self.contentSize.width/2,self.contentSize.height/2 - 50)
    
    --[[if not position then
        position = cc.p(self.contentSize.width/2,self.contentSize.height/2 - 50)
	end--]]
	
	local label = ccui.Text:create()
	label:setString(msg)
	label:setFontSize(self.fontSize)
	label:setColor(color)
    label:setScale(1.5)

			
	local size = label:getContentSize()
	if size.width > self.contentSize.width then
		self.upHeight = math.ceil(size.width / self.contentSize.width) * size.height
        label:setContentSize(self.contentSize.width,self.upHeight)
	end
	
	label:setTag(self.frontTag)
	self:addChild(label)
    label:setPosition(position)
    local delayTime = cc.DelayTime:create(2)
	local fadeOut = cc.FadeOut:create(1)
	local function delayCallBackFunc()
		self.rearTag = label:getTag()
		label:removeFromParent()
	end
	local delayCallBack = cc.CallFunc:create(delayCallBackFunc)
	local sequence = cc.Sequence:create(delayTime,fadeOut,delayCallBack)
	label:runAction(sequence)
	
	if not pos then
        local moveAction = cc.MoveBy:create(0.2, cc.p(0, 50))
        label:runAction(moveAction)
    end
   
    local scaleAction = cc.ScaleTo:create(0.2, 1.0)
    label:runAction(scaleAction)
    
	
	self:adjustLayout()
	self.frontTag = self.frontTag+1
	
end


return SystemTipsLayer