

local AnnounceLayer = class("AnnounceLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function AnnounceLayer.create()
    local layer = AnnounceLayer.new()
    return layer
end


function AnnounceLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
    self.readFileStringManager = nil -- 资源管理器对象
	self.selectTag = 1
	self.fontSize = 20
	self.gap = 5
	self.totalHeight = 0
end


function AnnounceLayer:getReadFileStringManager()

    if nil == self.readFileStringManager then 
	local announcement = require("src.update.AnnouncementOfSdk")
	print(announcement)
	self.readFileStringManager = wd.ReadFileStringManager:new(announcement)
        --self.readFileStringManager = wd.ReadFileStringManager:new("http://ttlx.oss-cn-hangzhou.aliyuncs.com/wending%2Ftiantianliexue%2Fannouncement%2Fannouncement")
		--self.readFileStringManager = wd.ReadFileStringManager:new("http://ttlx.oss-cn-hangzhou.aliyuncs.com/wending%2Ftiantianliexue%2Ftest%2Ftest")
            
        self:addChild(self.readFileStringManager)

        self.readFileStringManager:setConnectionTimeout(3)
    end

    return self.readFileStringManager
end



function AnnounceLayer:checkUpdate()
    if self:getReadFileStringManager():checkUpdate() == true then
        self:createLayerMenu()
        return true
    else
        return false
    end

end

function AnnounceLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/setting/AnnounceScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)
    
	local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Close_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
				if self.announcementList then
					for i,v in ipairs(self.announcementList) do
						if v.richLabelList then
							for k,p in ipairs(v.richLabelList) do
								p:relaese()
								v.richLabelList[k] = nil
							end
						end
					end
				end
            end
        end
    )
	
	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
	local contentScroll =  tolua.cast(mainPanel:getChildByName("Announce_Content_Scroll"), "ccui.ScrollView")
	local titleLabel = tolua.cast(mainPanel:getChildByName("Title_Label"), "ccui.Text")
	--titleLabel:setColor(wd.announcementColor["YELLOW"])
	local selectList =  tolua.cast(ccui.Helper:seekWidgetByName(node,"Announce_List"), "ccui.ListView")	
	
	self.announcementList = {}
	local contentStr = wd.GlobalData:getInstance():getAnnoucement()
	local str = contentStr 
	while (str ~= "")
	do
		local announcement = {}
		local startP = string.find(str,"#")
		str = string.sub(str,startP+1,-1)
		local endP = string.find(str,"#")
		local parse = string.sub(str,1,endP-1)
		local startIndex,endIndex,titleStr = string.find(parse,"{t=%[(.-)%]}")
		announcement.title = titleStr
		parse = string.sub(parse,endIndex+1,-1)
		startP = string.find(parse,"\r\n")
		parse = string.sub(parse,startP+2,-1)
		local oneLineWord
		local richLabelList = {}
		local subParse = parse
		while(subParse ~= "")
		do
			startP = string.find(subParse,"\r\n")
			oneLineWord = string.sub(subParse,1,startP-1)
			local richTextLabel = ccui.RichText:create()
			local richElementList = self:parseWord(oneLineWord)
			if richElementList then
				for i,v in ipairs(richElementList) do
					richTextLabel:pushBackElement(v)
				end
			end
			richTextLabel:formatText()
			local labelSize = richTextLabel:getContentSize()
			if labelSize.width > contentScroll:getContentSize().width - self.fontSize then
				self.upHeight = math.ceil(labelSize.width / (contentScroll:getContentSize().width- self.fontSize))* labelSize.height
			else
				self.upHeight = labelSize.height
			end
			richTextLabel:ignoreContentAdaptWithSize(false)
			richTextLabel:setContentSize(contentScroll:getContentSize().width- self.fontSize,self.upHeight)
			
			richTextLabel:retain()
			table.insert(richLabelList,richTextLabel)
			subParse = string.sub(subParse,startP+2,-1)
		end
		announcement.richLabelList = richLabelList
		table.insert(self.announcementList,announcement)
		str = string.sub(str,endP+1,-1)
	end
	
	local function updateScroll(totalStr)
		self.totalHeight = 0
		contentScroll:removeAllChildren()
		local titleStr = totalStr.title
		local richLabelList = totalStr.richLabelList
		titleLabel:setString(titleStr)
		local size = contentScroll:getContentSize()
		
		local layer = ccui.Widget:create()
		
		local lastHeight,lastPosX,lastPosY = 0,0,0
		if richLabelList then
			for i,v in ipairs(richLabelList) do
				layer:addChild(v)
				if i == 1 then
					v:setPosition(v:getContentSize().width/2+10,-v:getContentSize().height/2-self.gap)
				else
					v:setPosition(v:getContentSize().width/2+10,lastPosY-lastHeight/2-v:getContentSize().height/2-self.gap)
				end
				lastHeight = v:getContentSize().height
				lastPosX,lastPosY = v:getPosition()
				self.totalHeight = self.totalHeight + lastHeight + self.gap
			end
		end
		
		local signLabel =  cc.Label:create()
		signLabel:setSystemFontSize(self.fontSize)
		signLabel:setColor(cc.c3b(0,0x68,0xc0))
		signLabel:setString("运营团队")
		signLabel:setAnchorPoint(cc.p(0,1))
		layer:addChild(signLabel)
		signLabel:setPosition(contentScroll:getContentSize().width-signLabel:getContentSize().width-25,lastPosY-lastHeight/2-20)
		self.totalHeight = self.totalHeight + 20
		
		contentScroll:setInnerContainerSize(cc.size(contentScroll:getContentSize().width,self.totalHeight+self.fontSize*2))
		contentScroll:addChild(layer)
		layer:setPosition(0,contentScroll:getInnerContainerSize().height)
		contentScroll:jumpToTop()
	end
	
	local function updateContent(sender,eventType)
		if eventType == ccui.TouchEventType.ended then
			if self.selectTag == sender:getTag() then
				return
			end
			wd.setSelectBox(selectList,self.selectTag,sender:getTag())
			self.selectTag = sender:getTag()
			updateScroll(self.announcementList[self.selectTag])
		end
	end
	local count = #self.announcementList
	for i = 1,count do
		local announceNode = tolua.cast(cc.CSLoader:createNode("ui/setting/AnnounceNode.csb"),"ccui.Widget")
		local btn = ccui.Button:create("setting_announce_tab_normal.png", "setting_announce_tab_normal.png", "", ccui.TextureResType.plistType)
		btn:setAnchorPoint(cc.p(0,0))
		btn:setTag(i)
		btn:addTouchEventListener(updateContent)
		announceNode:setTag(i)
		btn:addChild(announceNode)
		local selectBox = tolua.cast(announceNode:getChildByName("Select_Sprite"), "cc.Sprite")
		if i == 1 then
			selectBox:setVisible(true)
			updateScroll(self.announcementList[1])
		else
			selectBox:setVisible(false)
		end
		local titleLabel = tolua.cast(announceNode:getChildByName("Title_Label"), "ccui.Text")
		titleLabel:setString(self.announcementList[i].title)
		titleLabel:setColor(wd.announcementColor["YELLOW"])
		if titleLabel:getContentSize().width > 5*22 then
			titleLabel:ignoreContentAdaptWithSize(false)
			titleLabel:setContentSize(cc.size(5*22,70))
			local x,y = titleLabel:getPosition()
			titleLabel:setPosition(x,y+10)
		end
		
		selectList:pushBackCustomItem(btn)
	end
end

function AnnounceLayer:parseWord(msg)
	local richElementList = {}
	local startIndex,lastIndex,str,color,index,colorStr
	local parsedStr = msg
	self.tag = 1
	if type(parsedStr) == "string" then	
		local circleTime = 0
		while (string.find(parsedStr,"{") ~= nil)	
		do
			if circleTime > 30 then
				break
			end
			
			index= string.find(parsedStr,"{")
			local strType = string.sub(parsedStr,index+1,index+1)
			-- 红
			if strType == "r" then
				startIndex,lastIndex,str = string.find(parsedStr,"{r=%[(.-)%]}")  
				color = wd.announcementColor["RED"]
			elseif strType == "b" then
				startIndex,lastIndex,str = string.find(parsedStr,"{b=%[(.-)%]}")  
				color = wd.announcementColor["BLUE"]
			elseif strType == "p" then
				startIndex,lastIndex,str = string.find(parsedStr,"{p=%[(.-)%]}")  
				color = wd.announcementColor["PURPLE"]
			elseif strType == "y" then
				startIndex,lastIndex,str = string.find(parsedStr,"{y=%[(.-)%]}")  
				color = wd.announcementColor["YELLOW"]
			end
			if startIndex and lastIndex and str then
				richElementList = self:parseStrAndSetRichElement(richElementList,parsedStr,startIndex,lastIndex,str,color)
				parsedStr = string.sub(parsedStr,lastIndex+1,-1)
			end
			circleTime = circleTime + 1
		end
		parsedStr = string.sub(parsedStr,1,-1) 
		local richElement = ccui.RichElementText:create(self.tag,cc.c3b(255,255,255),255,parsedStr,"Helvetica",self.fontSize)
		self.tag = self.tag+1
		table.insert(richElementList,richElement)
		
		return richElementList
	end
end

function AnnounceLayer:parseStrAndSetRichElement(richElementList,parsedStr,startIndex,lastIndex,str,color)
	if not color then
		color = cc.c3b(255,0,0)
	end
	parsedStr = string.sub(parsedStr,1,startIndex-1)
	local richElement = ccui.RichElementText:create(self.tag,cc.c3b(255,255,255),255,parsedStr,"Helvetica",self.fontSize)
	self.tag = self.tag+1
	table.insert(richElementList,richElement)
	richElement = ccui.RichElementText:create(self.tag,color,255,str,"Helvetica",self.fontSize)
	self.tag = self.tag+1
	table.insert(richElementList,richElement)
	return richElementList
end

return AnnounceLayer